
clear all
set more off
global root "PATH/TO/REPLICATION/"
cd "${root}"
global econ_paper "econ_Paper_Level_clean.dta"

program main
	combine_ECM2020, field(econ)
	AAAS, field(econ)
	NAS, field(econ)
	AEA, field(econ)
	NBER, field(econ)
	sloan, field(econ)
	EMA_lecture, field(econ)


end


program clean_special	
	replace author = subinstr(author, "’", "'", .)
	
	replace author = subinstr(author, "Á", "A", .)
	replace author = subinstr(author, "Å", "A", .)
	replace author = subinstr(author, "Ä°", "A", .)
	replace author = subinstr(author, "Ä", "A", .)
	replace author = subinstr(author, "Ã", "A", .)
	replace author = subinstr(author, "Ā", "A", .)
	replace author = subinstr(author, "Ã", "A", .)
	replace author = subinstr(author, "Ã³", "A", .)
	replace author = subinstr(author, "å", "a", .)
	replace author = subinstr(author, "á", "a", .)
	replace author = subinstr(author, "à", "a", .)
	replace author = subinstr(author, "ä", "a", .)
	replace author = subinstr(author, "æ", "ae", .)
	replace author = subinstr(author, "ã", "a", .)
	replace author = subinstr(author, "â", "a", .)
	replace author = subinstr(author, "a¹", "a", .)
	replace author = subinstr(author, "a¶", "o", .)
	replace author = subinstr(author, "a¤", "a", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00a4"), "a") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00a4"), "a") 
	
	replace author = subinstr(author, "ß", "b", .)
	
	replace author = subinstr(author, "č", "c", .)
	replace author = subinstr(author, "ć", "c", .)
	replace author = subinstr(author, "c̆", "c", .)
	replace author = subinstr(author, "Ç", "C", .)
	replace author = subinstr(author, "ç", "c", .)
	replace author = subinstr(author, "¢", "c", .)
	replace author = subinstr(author, "Č", "C", .)
	replace author = subinstr(author, "©", "c", .)
	replace author = subinstr(author, "§", "c", .)
	
	replace author = subinstr(author, "É", "E", .)
	replace author = subinstr(author, "Ë", "E", .)
	replace author = subinstr(author, "é", "e", .)
	replace author = subinstr(author, "è", "e", .)
	replace author = subinstr(author, "ě", "e", .)
	replace author = subinstr(author, "ë", "e", .)
	replace author = subinstr(author, "ȩ", "e", .)
	
	replace author = subinstr(author, "ǧ", "g", .)
	replace author = subinstr(author, "ğ", "g", .)
	replace author = subinstr(author, "ǧ̃", "g", .)
	replace author = subinstr(author, "g̃", "g", .)
	replace author = subinstr(author, "gˇ", "g", .)
	replace author = subinstr(author, "Ğ", "g", .)
	replace author = subinstr(author, "ḡ", "g", .)
	
	replace author = subinstr(author, "İ", "I", .)
	replace author = subinstr(author, "Î", "I", .)
	replace author = subinstr(author, "Í", "I", .)
	replace author = subinstr(author, "Ì", "I", .)
	replace author = subinstr(author, "Ï", "I", .)
	replace author = subinstr(author, "i̇", "i", .)
	replace author = subinstr(author, "ı̈", "i", .)
	replace author = subinstr(author, "ï", "i", .)
	replace author = subinstr(author, "ı¨", "i", .)
	replace author = subinstr(author, "ı́", "i", .)
	replace author = subinstr(author, "í", "i", .)
	replace author = subinstr(author, "ĭ", "i", .)
	replace author = subinstr(author, "iˇ", "i", .)
	replace author = subinstr(author, "iˆ", "i", .)
	replace author = subinstr(author, "ı", "i", .)
	replace author = subinstr(author, "î", "i", .)
	replace author = subinstr(author, "¡", "i", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00ad"), "i") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00ad"), "i") 
	
	replace author = subinstr(author, "Ł", "L", .)
	replace author = subinstr(author, "Ľ", "L", .)
	replace author = subinstr(author, "ł", "l", .)
	
	replace author = subinstr(author, "Ñ", "N", .)
	replace author = subinstr(author, "ń", "n", .)
	replace author = subinstr(author, "ñ", "n", .)
	
	replace author = subinstr(author, "Ø", "O", .)
	replace author = subinstr(author, "Ó", "O", .)
	replace author = subinstr(author, "Ö", "O", .)
	replace author = subinstr(author, "Ò", "O", .)
	replace author = subinstr(author, "Ō", "O", .)
	replace author = subinstr(author, "ö", "o", .)
	replace author = subinstr(author, "Ó", "O", .)
	replace author = subinstr(author, "ó", "o", .)
	replace author = subinstr(author, "ò", "o", .)
	replace author = subinstr(author, "ø", "o", .)
	replace author = subinstr(author, "ô", "o", .)
	replace author = subinstr(author, "ő", "o", .)
	replace author = subinstr(author, "œ", "oe", .)
	replace author = subinstr(author, "Œ", "oe", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00b6"), "o") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00b6"), "o") 
	
	replace author = subinstr(author, "ř", "r", .)
	
	replace author = subinstr(author, "š", "s", .)
	replace author = subinstr(author, "ş", "s", .)
	replace author = subinstr(author, "Š", "S", .)
	replace author = subinstr(author, "Ş", "S", .)
	replace author = subinstr(author, "Ś", "S", .)
	
	replace author = subinstr(author, "ü", "u", .)
	replace author = subinstr(author, "ú", "u", .)
	replace author = subinstr(author, "ü", "u", .)
	replace author = subinstr(author, "Ü", "U", .)
	replace author = subinstr(author, "Ú", "U", .)
	
	replace author = subinstr(author, "ý", "y", .)
	
	replace author = subinstr(author, "Ž", "Z", .)
	replace author = subinstr(author, "ž", "z", .)
	
	
	replace author = subinstr(author, " ", " ", .)
	replace author = subinstr(author, "–", "-", .)
	replace author = subinstr(author, "‐", "-", .)
	replace author = subinstr(author, "¨", "-", .)
end

program name_parse
	* parse the names
	split author, parse(" ")
	local nsplit = r(nvars)
	gen last_name = ""
	forval y = 1/`nsplit' {
		replace last_name = author`y' if !missing(author`y')
	}

	rename author1 first_name

	gen middle_name = ""
	forval y = 2/`nsplit' {
		replace middle_name = middle_name + " " + author`y' if !missing(author`y') & author`y' != last_name
	}
	replace middle_name = strtrim(middle_name)

	* change x. xxx xxx into xxx x. xxx
	gen fi = first_name
	replace first_name = middle_name if ustrregexm(first_name, "^[A-Z]\.")==1 & ustrregexm(middle_name, "[A-Za-z]\.") == 0 & lower(middle_name) != "de" & lower(middle_name) != "van" & lower(middle_name) != "von" & lower(middle_name) != "la" & middle_name != ""

	* change middle names to first initials 
	replace middle_name = substr(middle_name, 1, 1) + "." if strlen(middle_name) > 2 & strpos(middle_name, ".") == 0

	replace middle_name = fi if author2 == first_name

	gen author_full = first_name + " " + middle_name + " " + last_name if middle_name != ""
	drop fi author2-author`nsplit'
	
	order author_full first_name middle_name last_name

	* generate variables to match
	gen author_nomi = first_name + " " + last_name
	replace author_full = author_nomi if author_full == ""

	gen author_fellow = proper(author_full)
	replace author_full = proper(author_full)

	drop author first_name middle_name
	rename author_full author
end

program combine_ECM2020
	syntax, field(str)
	* append the 2020 elected fellows 
	local field = "econ"
	import delimited "${root}/`field'/input/raw/fellows_2020.csv", stringcols(1) encoding(UTF-8)clear
	clean_special
	replace author = proper(author)

	name_parse
	replace author = subinstr(author, ".", ". ", .)
	replace author = stritrim(author)
	
	tostring female, replace 
	local field = "econ"
	append using "${root}/`field'/input/raw/fellows.dta"
	drop no
	
	sort year_appointed last_name author

	merge m:1 author using "${root}/econ/output/replacement_names.dta", nogen keep(1 3) keepusing(replacement)
	replace author = replacement if replacement != ""
	replace author_fellow = replacement if replacement != ""
	drop replacement
    **** ==== Do not move this fix to name dictionary ==== ****
	replace author = "Lars E. O. Svensson" if author == "Lars Svensson"
	replace author = "Heidi L. Williams" if author == "Heidi Williams"
	replace author = "Joan-Maria Esteban" if author == "Joan M. Esteban"
	replace author = "Clive W. J. Granger" if author == "Clive W.J. Granger"
	replace author = "Christopher J. Harris" if author == "Christopher J. Harris"
	replace author = "Oliver D. Hart" if author == "Oliver Hart"
	replace author = "Preston R. Mcafee" if author == "Preston Mcafee"
	replace author = "John K. H. Quah" if author == "John K.H. Quah"
	replace author = "Kevin W. S. Roberts" if author == "Kevin W.W. Roberts"
	replace author = "William P. Rogerson" if author == "William R. Rogerson"
	replace author = "Jose Alexander Scheinkman" if author == "Jose Alexandre Scheinkman"
	replace author = "Marilda A. De Oliveira Sotomayor" if author == "Marilda Sotomayor"
	replace author = "Steven Tadelis" if author == "Steve Tadelis"
	replace author = "Richard H. Thaler" if author == "Richard Thaler"
	replace author = "Carl Christian Von Weizsacker" if author == "Carl Von Weizsacker"
	replace author = "Costantino Bresciani Turroni" if author == "Constantino Bresciani-Turroni"
	replace author = "Dorothy S. Brady" if author == "Dorothy E.S. Brady"
	replace author = "In-Koo Cho" if author == "In Koo Cho"
	replace author = "Martin S. Eichenbaum" if author == "Martin Eichenbaum"
	replace author = "Sergio Firpo" if author == "Sergio P. Firpo"
	replace author = "Jan Salomon Cramer" if author == "Jan Salomon (Mars) Cramer"
	replace author = "Christopher J. Harris" if author == "Christopher Harris"
	replace author = "Sergio P. Firpo" if author == "Sergio Firpo"
	replace author = "Gerard J. Van Den Berg" if author == "Gerard Van Den Berg"
	replace author = "Martin W. Cripps" if author == "Martin Cripps"
	replace author = "Pierre B. D. Masse" if author == "Pierre Masse"
	replace author = "Colin Grant Clark" if author == "Colin Clark"
	replace author = "Johannes Bernardus Dirk Derksen" if author == "J. B. D. Derksen"
	replace author = "Robert S. Gibbons" if author == "Robert Gibbons"
	replace author = "Randolph Preston Mcafee" if author == "Preston R. Mcafee"
	
	
	
	replace author_fellow = author 
	**** ================================================= ****
	
	replace female = "0" if last_name == "Watanabe"
	
	compress
	save "${root}/`field'/output/combined_fellows_clean.dta", replace
end

program AAAS
	syntax, field(str)
	* this files comes from the AAAS pdf (Paper2/AAAS/AAAS_fellows_list.pdf)
	* that contains fellows that are not listed on the AAAS website
	use "${root}/econ/input/raw/AAAS_pdf.dta", clear
	clean_special	
	replace author = subinstr(author, ".", ". ", .)
	replace author = stritrim(author)
	
	merge m:1 author using "${root}/econ/output/replacement_names.dta", nogen keep(1 3) keepusing(replacement)
	replace author = replacement if replacement != ""
	drop replacement
	rename year year_appointed_AAAS
	* Handmatch these individuals
	replace author = "Stephen Polasky" if author == "A. Stephen Polasky"
	replace author = "Abba P. Lerner" if author == "Abba Ptachya Lerner"
	replace author = "Alan S. Manne" if author == "Alan Sussman Manne"
	replace author = "Alexander Gerschenkron" if author == "Alexander Pavlovich Gerschenkron"
	replace author = "Alfred C. Neal" if author == "Alfred Clarence Neal"
	replace author = "Alice M. Rivlin" if author == "Alice Mitchell Rivlin"
	replace author = "Arthur E. Monroe" if author == "Arthur Eli Monroe"
	replace author = "Arthur M. Okun" if author == "Arthur Melvin Okun"
	replace author = "Avinash K. Dixit" if author == "Avinash Kamalakar Dixit"
	replace author = "Bertil Ohlin" if author == "Bertil Gotthard Ohlin"
	replace author = "Bishop C. Hunt" if author == "Bishop Carleton Hunt"
	replace author = "Carter Goodrich" if author == "Carter Lyman Goodrich"
	replace author = "Charles A. Myers" if author == "Charles Andrew Myers"
	replace author = "Daniel M. Hausman" if author == "Daniel Murray Hausman"
	replace author = "David Bell" if author == "David Elliott Bell"
	replace author = "Dennis H. Robertson" if author == "Dennis Holme Robertson"
	replace author = "Douglass V. Brown" if author == "Douglass Vincent Brown"
	replace author = "Edgar Stevenson Furniss" if author == "Edgar Stephenson Furniss"
	replace author = "Edmund E. Day" if author == "Edmund Ezra Day"
	replace author = "Edward H. Chamberlin" if author == "Edward Hastings Chamberlin"
	replace author = "Edwin G. Nourse" if author == "Edwin Griswold Nourse"
	replace author = "Erik Lundberg" if author == "Erik Filip Lundberg"
	replace author = "Frank H. Knight" if author == "Frank Hyneman Knight"
	replace author = "George N. Halm" if author == "George Nikolaus Halm"
	replace author = "George P. Baker" if author == "George Pierce Baker"
	replace author = "Harry A. Millis" if author == "Harry Alvin Millis"
	replace author = "Harry G. Johnson" if author == "Harry Gordon Johnson"
	replace author = "Harry R. Tosdal" if author == "Harry Rudolph Tosdal"
	replace author = "Harvey S. Perloff" if author == "Harvey Stephen Perloff"
	replace author = "Herbert A. Simon" if author == "Herbert Alexander Simon"
	replace author = "Herman O. A. Wold" if author == "Herman Ole Andraeas Wold"
	replace author = "Zvi Griliches" if author == "Hirsh Zvi Griliches"
	replace author = "Hollis B. Chenery" if author == "Hollis Burnley Chenery"
	replace author = "Howard S. Ellis" if author == "Howard Sylvester Ellis"
	replace author = "Jakob Marschak" if author == "Jacob Marschak"
	replace author = "Joan Robinson" if author == "Joan Violet Maurice Robinson"
	replace author = "Franklin J. Ebersole" if author == "John Franklin Ebersole"
	replace author = "John H. Habakkuk" if author == "John Hrothgar Habakkuk"
	replace author = "John M. Keynes" if author == "John Maynard Keynes"
	replace author = "John Lintner" if author == "John Virgil Lintner"
	replace author = "Joseph A. Schumpeter" if author == "Joseph Alois Schumpeter"
	replace author = "Joseph H. Willits" if author == "Joseph Henry Willits"
	replace author = "Lester C. Thurow" if author == "Lester Carl Thurow"
	replace author = "Lionel Robbins" if author == "Lionel Charles Robbins"
	replace author = "Lloyd A. Metzler" if author == "Lloyd Appleton Metzler"
	replace author = "Lloyd S. Shapley" if author == "Lloyd Stowell Shapley"
	replace author = "Malcolm P. Mcnair" if author == "Malcolm Perrine Mcnair"
	replace author = "Mancur Olson" if author == "Mancur Lloyd Olson"
	replace author = "Marina V. N. Whitman" if author == "Marina Von Neumann Whitman"
	replace author = "Marshall I. Goldman" if author == "Marshall Irwin Goldman"
	replace author = "Max Millikan" if author == "Max Franklin Millikan"
	replace author = "Michael C. Jensen" if author == "Michael Cole Jensen"
	replace author = "Ragnar Frisch" if author == "Ragnar Anton Kittil Frisch"
	replace author = "Richard S. Meriam" if author == "Richard Stockton Meriam"
	replace author = "Robert D. Calkins" if author == "Robert Deblois Calkins"
	replace author = "Robert J. Aumann" if author == "Robert John Aumann"
	replace author = "Roswell C. Mccrea" if author == "Roswell Cheney Mccrea"
	replace author = "Seymour E. Harris" if author == "Seymour Edwin Harris"
	replace author = "Sheldon Danziger" if author == "Sheldon H. Danziger"
	replace author = "Sidney S. Alexander" if author == "Sidney Stuart Alexander"
	replace author = "Theodore O. Yntema" if author == "Theodore Otte Yntema"
	replace author = "Thomas R. Palfrey" if author == "Thomas R. Palfreyi"
	replace author = "Wilfred S. Lake" if author == "Wilfred Stanley Lake"
	replace author = "William J. Fellner" if author == "William John Fellner"
	replace author = "Rupert W. Maclaurin" if author == "William Rupert Maclaurin"
	replace author = "Winthrop M. Daniels" if author == "Winthrop More Daniels"
	
	
	replace author = "Allyn A. Young" if author == "Allyn Abbott Young"
	replace author = "Arthur S. Dewing" if author == "Arthur Stone Dewing"
	replace author = "Charles F. Dunbar" if author == "Charles Franklin Dunbar"
	replace author = "Charles J. Bullock" if author == "Charles Jesse Bullock"
	replace author = "Davis R. Dewey" if author == "Davis Rich Dewey"
	replace author = "Donald S. Tucker" if author == "Donald Skeele Tucker"
	replace author = "Edwin F. Gay" if author == "Edwin Francis Gay"
	replace author = "Francis A. Walker" if author == "Francis Amasa Walker"
	replace author = "Frank W. Taussig" if author == "Frank William Taussig"
	replace author = "Frederick C. Mills" if author == "Frederick Cecil Mills"
	replace author = "George P. Baker" if author == "George Pierce Baker"
	replace author = "Harold G. Moulton" if author == "Harold Glenn Moulton"
	replace author = "John B. Clark" if author == "John Bates Clark"
	replace author = "John D. Black" if author == "John Donald Black"
	replace author = "John H. Williams" if author == "John Henry Williams"
	replace author = "Oliver M. W. Sprague" if author == "Oliver Mitchell Wentworth Sprague"
	replace author = "Warren M. Persons" if author == "Warren Milton Persons"
	replace author = "Wesley C. Mitchell" if author == "Wesley Clair Mitchell"
	replace author = "William J. Cunningham" if author == "William James Cunningham"
	replace author = "William L. Crum" if author == "William Leonard Crum"
	replace author = "William Z. Ripley" if author == "William Zebina Ripley"
	tempfile pdf 
	save "`pdf'"
	
	
	use "${root}/AAAS/AAAS.dta" if subfield == "Economics", clear 

	drop institution occupation field subfield status Male Ambiguous 

	rename year year_appointed_AAAS
	rename (Female fellow) (female_AAAS author)

	clean_special
	
	replace author = proper(author)

	name_parse
	replace author = subinstr(author, ".", ". ", .)
	replace author = stritrim(author)
	
	merge m:1 author using "${root}/econ/output/replacement_names.dta", nogen keep(1 3) keepusing(replacement)
	replace author = replacement if replacement != ""
	replace author_fellow = replacement if replacement != ""
	drop replacement
	
	
	replace author = "Carl Christian Von Weizsacker" if author == "Carl C. Weizsacker"
	replace author = "Clive W. J. Granger" if author == "Clive W. Granger"
	replace author = "Cynthia Taft Morris" if author == "Cynthia Taft-Morris"
	replace author = "Donald W. K. Andrews" if author == "Donald W. Andrews"
	replace author = "Herman O. A. Wold" if author == "Herman O. Wold"
	replace author = "Jean-Jacques M. Laffont" if author == "Jean-Jacques Laffont"
	replace author = "Nicholas H. Stern" if author == "Nicholas H. Stern Fba"
	replace author = "Oliver D. Hart" if author == "Oliver S. Hart"
	replace author = "Peter C. B. Phillips" if author == "Peter C. Phillips"
	replace author = "Rudi Dornbusch" if author == "Rudiger W. Dornbusch"
	replace author = "Arthur W. Lewis" if author == "William Arthur Lewis"
	replace author = "William M. T. Gorman" if author == "William Moore Gorman"
	replace author = "Gale D. Johnson" if author == "David G. Johnson"
	replace author = "Gary E. Chamberlain" if author == "Gary Chamberlain"
	replace author = "Gunnar Myrdal" if author == "Karl G. Myrdal"
	replace author = "Costas Meghir" if author == "Konstantinos E.D. Meghir"
	replace author = "Robin C. Matthews" if author == "Robert C. Matthews"
	replace author = "Arthur W. Lewis" if author == "William A. Lewis"
	replace author = "Gerard J. Van Den Berg" if author == "Gerard Van Den Berg"
	replace author = "Stephen J. Nickell" if author == "Stephen N. Fba"
	replace author = "Costas Meghir" if author == "Konstantinos E. D. Meghir"
	replace author = "Susan C. Athey" if author == "Susan Athey"
	replace author = "Gardner Ackley" if author == "Hugh G. Ackley"
	replace author = "Michael A. Spence" if author == "Andrew M. Spence"
	replace author = "William A. Brock" if author == "William A. Brocki"
	replace author = "Richard J. Stone" if author == "John R. Stone"
	replace author = "Robert E. Lucas" if author == "Robert E. Lucas Jr."
	replace author = "Robert J. Shimer" if author == "Robert Shimer"
	replace author = "Pierre B. D. Masse" if author == "Pierre Masse"
	replace author = "Gregg H. Lewis" if author == "Harold G. Lewis"
	replace author = "Jose Alexander Scheinkman" if author == "Jose A. Scheinkman"
	replace author = "Lloyd Dewitt Brace" if author == "Lloyd D. Brace"
	
	merge 1:1 author year using "`pdf'", keepusing(AAAS_flags)
	replace author_fellow = author 
	replace AAAS_flags = 1 if missing(AAAS_flags)
	
	* fillin genders for unmatched AAAS fellows
	replace female = 0 if author == "Alfred Sauvy"
	replace female = 1 if author == "Barbara Ward"
	replace female = 0 if author == "Boris G. Saltykov"
	replace female = 0 if author == "Daniel Cosio Villegas"
	replace female = 0 if author == "David Ames Wells"
	replace female = 0 if author == "Eduardo J. Padron"
	replace female = 0 if author == "Geoffrey Crowther"
	replace female = 0 if author == "Gosta Adolfsson Bagge"
	replace female = 0 if author == "Henry Charles Carey"
	replace female = 0 if author == "James Douglas Brown"
	replace female = 0 if author == "James Frederic Dewhurst"
	replace female = 1 if author == "Jane I. Guyer"
	replace female = 0 if author == "John Grenfell Crawford"
	replace female = 0 if author == "Lloyd Dewitt Brace"
	replace female = 0 if author == "Michael Moissey Postan"
	replace female = 0 if author == "Ralph Evans Freeman" 
	replace female = 0 if author == "Ralph George Hawtrey" 
	replace female = 0 if author == "Robert D. Reischauer"
	replace female = 0 if author == "Thomas Henry Sanders"
	replace female = 0 if author == "Thomas North Whitehead"
	replace female = 0 if author == "Vivian Wilson Henderson"
	replace female = 0 if author == "Walter Wallace Mclaren"
	replace female = 0 if author == "Werner Sombart"
	
	* one duplicate for George Pierce Baker that is clearly wrong
	drop if author == "George P. Baker" & year == 1947
	compress
	save "${root}/`field'/output/AAAS_fellows_clean.dta", replace
end


program NAS
	syntax, field(str)
	* Prepare 2nd field indicator
	local field = "econ"
	use "${root}/NAS\NAS_econ.dta", clear

	gen reversed = reverse(fellow)
	split reversed, parse(" ")

	forval x = 1/4 {
		replace reversed`x' = reverse(reversed`x')
	}
	gen name = reversed2 + " " + reversed3 + " " + reversed4
	replace name = strtrim(name)
	rename reversed1 last_name
	drop reversed reversed2-reversed4
	drop fellow
	rename year year_appointed_NAS
	gen primary_NAS_econ = strpos(primary, "Economic")
	drop primary secondary
	order last_name year_appointed_NAS
	keep last_name year_appointed_NAS primary
	duplicates drop
	* check that we have not dropped any fellows
	tempfile secondary
	save "`secondary'"

	assert _N == 146
	*** clean the NAS fellows
	import excel "${root}/`field'/input/raw/NA_Fellows_Elected.xlsx", sheet("NationalAcademyEconomist") firstrow clear

	drop institution no

	rename year_elected year_appointed_NAS
	rename female female_NAS

	replace name = strtrim(name)
	replace lastname = strtrim(lastname)

	replace name = "Thirukodikaval N." if lastname == "Srinivasan"
	replace name = "Hirofumi" if lastname == "Uzawa"
	replace name = "Robert B." if name == "Robert" & lastname == "Wilson"
	replace name = "Edward C." if name == "Edward" & lastname == "Prescott"
	replace name = "Robert E." if name == "Robert" & lastname == "Lucas Jr."
	replace name = "Gale D." if name == "David Gale" & lastname == "Johnson"

	gen author = name + " " + lastname
	
	clean_special
	
	replace author = proper(author)

	replace author = "C. Y. Cyrus Chu" if author == "C.Y. Cyrus Chu"
	replace name = "C. Y. Cyrus" if name == "C.Y. Cyrus"

	name_parse

	compress
	save "${root}/`field'/output/NAS_fellows_clean.dta", replace

	* append the fellows whose secondary field is economics 
	use  "${root}/`field'/input/raw/NAS_econ.dta", clear /* initially left out of the fellows dataset */
	keep if secondary == "Economic Sciences" | fellow == "Theodore Schultz" | fellow == "James Poterba" | fellow == "George Stigler" 

	drop institution primary secondary 
	rename (fellow female year) (author female_NAS year_appointed_NAS) 

	name_parse

	append using "${root}/`field'/output/NAS_fellows_clean.dta"
	
	replace author = subinstr(author, ".", ". ", .)
	replace author = stritrim(author)
	duplicates drop author year, force 
	
	merge m:1 author using "${root}/econ/output/replacement_names.dta", nogen keep(1 3) keepusing(replacement)
	replace author = replacement if replacement != ""
	replace author_fellow = replacement if replacement != ""
	drop replacement
	
	replace author = "Geoffrey M. Heal" if author == "Geoffry Heal"
	replace author = "Jose Alexander Scheinkman" if author == "Jose Scheinkman"
	replace author = "Lawrence R. Klein" if author == "Lawrence Klein"
	replace author = "Oliver D. Hart" if author == "Oliver Hart"
	replace author = "Richard H. Thaler" if author == "Richard Thaler"
	replace author = "Theodore W. Anderson" if author == "Theodore Anderson"
	replace author = "Thomas C. Schelling" if author == "Thomas Schelling"
	replace author = "Edward F. Denison" if author == "Edward Denison"
	replace author = "Robert E. Lucas" if author == "Robert E. Lucas Jr."
	replace author = "Douglas B. Bernheim" if author == "Douglas Bernheim"
	replace author = "In-Koo Cho" if author == "In K. Cho"
	replace author = "Jeffrey A. Miron" if author == "Jeffrey Miron"
	replace author = "John N. Friedman" if author == "John Friedman"
	replace author = "John C. Harsanyi" if author == "John Harsanyi"
	replace author = "Donald G. Saari" if author == "Donald Saari"
	replace author = "Arthur S. Goldberger" if author == "Arthur Goldberger"
	replace author = "Robert E. Lucas" if author == "Robert E. Lucas Jr."
	replace author = "Robert E. Lucas" if author == "Robert E. Lucas Jr. "
	replace last_name = "Lucas" if author == "Robert E. Lucas"
	replace author = "Anastasios P. Xepapadeas" if author == "Anastasios Xepapadeas"
	replace author = "Theodore W. Schultz" if author == "Theodore Schultz"

	* merge in 2ndary field
	merge 1:1 last_name year_appointed_NAS using "`secondary'", nogen keepusing (primary)
	drop name lastname
	replace author_fellow = author 
	compress
	save "${root}/`field'/output/NAS_fellows_clean.dta", replace
end

program AEA
	syntax, field(str)
	*** clean the AEA distinguished fellows
	local field = "econ"
	import delimited "${root}/`field'/input/raw/AEA_Distinguished_Fellows_Elected.csv", encoding(UTF-8)clear

	drop no v7 v8 v9 v10 original

	rename year_elected year_appointed_AEA
	rename female female_AEA

	replace name = strtrim(name)
	replace lastname = strtrim(lastname)

	replace name = "Thirukodikaval N." if lastname == "Srinivasan" & name == "T.N."
	replace name = "Gale D." if name == "D. Gale" & lastname == "Johnson"
	replace name = "Rudi" if name == "Rudiger W." & lastname == "Dornbusch"
	replace name = "Jakob" if name == "Jacob" & lastname == "Marschak"
	replace lastname = "Rosenstein-Rodan" if lastname == "Rosenstein-Rodin"
	replace name = "P. N." if name == "Paul" & lastname == "Rosenstein-Rodan"
	replace name = "Richard B. " if name == "Richard" & lastname == "Freeman"
	replace lastname = "Schultze" if name == "Charles L." & lastname == "Shultze"

	gen author = name + " " + lastname

	clean_special
	
	replace author = proper(author)

	name_parse
	replace author = subinstr(author, ".", ". ", .)
	replace author = stritrim(author)
	
	merge m:1 author using "${root}/econ/output/replacement_names.dta", nogen keep(1 3) keepusing(replacement)
	replace author = replacement if replacement != ""
	replace author_fellow = replacement if replacement != ""
	drop replacement
	
	replace author = "Oliver D. Hart" if author == "Oliver Hart"
	replace author = "Ludwig V. Mises" if author == "Ludwig E. Mises"
	replace author = "Richard H. Thaler" if author == "Richard Thaler"
	replace author = "Arthur W. Lewis" if author == "William A. Lewis"
	replace author = "Walter Y. Oi" if author == "Walter Oi"
	replace author = "Joseph A. Pechman" if author == "Joseph Pechman"
	replace author = "Paul Narcyz Rosenstein-Rodan" if author == "P. N. Rosenstein-Rodan"
	replace author = "Thomas J. Rothenberg" if author == "Thomas Rothenberg"
	replace author = "Robert A. Pollak" if author == "Robert Pollak"
	replace author = "Clive W. J. Granger" if author == "Clive Granger"
	replace author_fellow = author 
	compress
	save "${root}/`field'/output/AEA_fellows_clean.dta", replace
end

*** clean the NBER fellows
program NBER
	syntax, field(str)
	clear
	local field = "econ"
	* the following files are .dta conversions of csvs found in input/raw/NBER/csv
	foreach file in ag ap cf ch dae dev ed eee efg hc he ifm io iti le ls me pe pol pr {
		append using  "${root}/`field'/input/raw/NBER/NBER_clean_`file'.dta"
	}

	gen tag = author_full + date_appointed1

	destring date_appointed1, replace
	sort author_full date_appointed1

	duplicates drop tag, force
	drop tag

	replace author_full = trim(author_full)

	gen id = _n

	drop if id == 305
	drop if id == 964
	drop if id == 1126
	drop if id == 1150

	replace author_full = "Mark D. Anderson" if id == 1571
	replace author_fellow = "Mark D. Anderson" if id == 1571
	replace author_nomi = "Mark Anderson" if id == 1571

	replace author_full = "Melissa S. Kearney" if id == 1029
	replace author_fellow = "Melissa S. Kearney" if id == 1029

	replace author_full = "John R. Graham" if id == 709
	replace author_fellow = "John R. Graham" if id == 709

	replace author_full = "Michael Carlos Best" if id == 1037
	replace author_fellow = "Michael Carlos Best" if id == 1037

	replace author_full = "Ariel Tomas Burstein" if id == 125
	replace author_fellow = "Ariel Tomas Burstein" if id == 125

	replace author_full = "Alberto Abadie" if id == 1568
	replace author_fellow = "Alberto Abadie" if id == 1568

	replace author_full = "Daron Acemoglu" if id == 1572
	replace author_fellow = "Daron Acemoglu" if id == 1572

	replace author_full = "Atila Abdulkadiroglu" if id == 1570
	replace author_fellow = "Atila Abdulkadiroglu" if id == 1570

	replace author_full = "Achyuta Adhvaryu" if id == 6
	replace author_fellow = "Achyuta Adhvaryu" if id == 6

	replace author_full = "Andrew B. Abel" if id == 1569
	replace author_fellow = "Andrew B. Abel" if id == 1569

	replace author_full = "David Albouy" if id == 1573
	replace author_fellow = "David Albouy" if id == 1573
	
	replace author_full = "James D. Adams" if id == 1574
	replace author_fellow = "James D. Adams" if id == 1574

	replace author_full = "Jason Abaluck" if id == 1575
	replace author_fellow = "Jason Abaluck" if id == 1575

	replace author_full = "Joseph E. Aldy" if id == 1576
	replace author_fellow = "Joseph E. Aldy" if id == 1576

	replace author_full = "Mark A. Aguiar" if id == 1577
	replace author_fellow = "Mark A. Aguiar" if id == 1577

	replace author_full = "Nikhil Agarwal" if id == 1578
	replace author_fellow = "Nikhil AAgarwal" if id == 1578

	replace author_full = "Orley C. Ashenfelter" if id == 1579
	replace author_fellow = "Orley C. Ashenfelter" if id == 1579
	replace author_nomi = "Orley Ashenfelter" if id == 1579

	replace author_full = "Ran Abramitzky" if id == 1580
	replace author_fellow = "Ran Abramitzky" if id == 1580

	replace author_full = "Rodrigo Adao" if id == 1581
	replace author_fellow = "Rodrigo Adao" if id == 1581

	replace author_full = "Viral V. Acharya" if id == 1582
	replace author_fellow = "Viral V. Acharya" if id == 1582

	replace author_full = "Mark Aguiar" if id == 1577
	replace author_fellow = "Mark Aguiar" if id == 1577

	
	replace author_full = "Yu-Chu Shen" if last_name == "Shen" & date_appointed1 == 2004
	replace author_fellow = "Yu-Chu Shen" if last_name == "Shen" & date_appointed1 == 2004
	replace author_nomi = "Yu-Chu Shen" if last_name == "Shen" & date_appointed1 == 2004

	rename date_appointed1 year_appointed_NBER

	rename author_full author
	replace author = subinstr(author, ".", ". ", .)
	replace author = stritrim(author)
	merge m:1 author using "${root}/econ/output/replacement_names.dta", nogen keep(1 3) keepusing(replacement)
	replace author = replacement if replacement != ""
	replace author_fellow = replacement if replacement != ""
	drop replacement
	drop id

	
	replace author = "Francisco J. Buera" if author == "Francisco J. . Buera"
	replace author = "Geoffrey M. Heal" if author == "Geoffry Heal"
	replace author = "Gerard Padro I. Miquel" if author == "Gerard Padro I Miquel"
	replace author = "Greg Colman" if author == "Gregory J. Colman"
	replace author = "John De Figueiredo" if author == "John M. De Figueiredo"
	replace author = "Kate M. Bundorf" if author == "Kate Bundorf"
	replace author = "Kelsey B. Jack" if author == "Kelsey Jack"
	replace author = "Marc J. Melitz" if author == "Marc Melitz"
	replace author = "Mariano Massimiliano Croce" if author == "Mariano Max Croce"
	replace author = "Renee T. Bowen" if author == "Renee Bowen"
	replace author = "Toni M. Whited" if author == "Toni Whited"
	replace author = "Walker W. Hanlon" if author == "Walker Hanlon"
	replace author = "Michael C. Best" if author == "Michael Carlos Best"
	replace author = "Gordon Phillips" if author == "G. Michael Phillips"
	replace author = "Achyuta Adhvaryu" if last_name == "Adhvaryu"
	replace author = "Clive W. J. Granger" if author == "Clive W. Granger"
	replace author = "Reed W. Walker" if author == "Reed Walker"
	replace author = "Jose Alexander Scheinkman" if author == "Jose A. Scheinkman"
	
	
	replace author_fellow = author 
	sort author year
	by author (year): keep if _n == 1
	compress
	save "${root}/`field'/output/NBER_fellows_clean.dta", replace
end


program sloan
	syntax, field(str)
	import excel "${root}/`field'/input/raw/Sloan_Fellows_Elected.xlsx", sheet("Sloan_Fellows") firstrow clear


	drop no field affiliation

	rename year_appointed year_appointed_Sloan
	rename female female_Sloan

	replace name = "Chris" if lastname == "Shannon" & name == "Christina"
	replace name = "Glen E." if name == "Eric" & lastname == "Weyl"
	replace lastname = "Dekel" if name == "Eddie" & lastname == "Dekel-Tabak"
	replace name = "Ben" if name == "Benjamin" & lastname == "Polak"
	replace name = "Frederic" if name == "Frederick" & lastname == "Mishkin"
	replace name = "George-Marios" if name == "George" & lastname == "Angeletos"
	replace name = "In Koo" if name == "In-Koo" & lastname == "Cho"
	replace lastname = "Kolesar" if lastname == "Kolesбr" & name == "Michal"
	replace name = "Patrik" if name == "Patrick" & lastname == "Guggenberger"
	replace lastname = "Myerson" if name == "Roger" & lastname == "Meyerson"
	replace name = "John R." if name == "John" & lastname == "Graham"
	replace name = "Charles I." if name == "Charles" & lastname == "Jones"
	replace name = "Bradford J." if name == "James" & lastname == "De Long"
	replace lastname = "Delong" if name == "Bradford J." & lastname == "De Long"
	replace lastname = "Muller" if name == "Ulrich" & lastname == "Mueller"
	replace name = "Ulrich K." if name == "Ulrich" & lastname == "Muller"
	replace name = "Dave" if name == "David" & lastname == "Donaldson"
	replace name = "Heidi L." if name == "Heidi" & lastname == "Williams"
	replace name = "John C." if name == "John" & lastname == "Heaton"
	replace name = "Lars Peter" if name == "Lars" & lastname == "Hansen"
	replace name = "Kevin M." if name == "Kevin" & lastname == "Murphy"
	replace name = "John Y." if name == "John" & lastname == "Campbell"
	replace name = "Charles A." if name == "Charles" & lastname == "Wilson"
	replace name = "Andrew B." if name == "Andrew" & lastname == "Abel"

	replace name = strtrim(name)
	replace lastname = strtrim(lastname)

	gen author = name + " " + lastname

	clean_special
	

	replace author = proper(author)

	name_parse
	replace author = subinstr(author, ".", ". ", .)
	replace author = stritrim(author)
	
	merge m:1 author using "${root}/econ/output/replacement_names.dta", nogen keep(1 3) keepusing(replacement)
	replace author = replacement if replacement != ""
	replace author_fellow = replacement if replacement != ""
	drop replacement
	
	replace author = "Donald W. K. Andrews" if author == "Donald Andrews"
	replace author = "Fernando E. Alvarez" if author == "Fernando Alvarez"
	replace author = "In-Koo Cho" if author == "In K. Cho"
	replace author = "Lee E. Ohanian" if author == "Lee Ohanian"
	replace author = "Marc J. Melitz" if author == "Marc Melitz"
	replace author = "Stephen E. Morris" if author == "Stephen Morris"
	replace author = "Thomas E. Macurdy" if author == "Thomas Macurdy"
	replace author = "Valerie A. Ramey" if author == "Valerie Ramey"
	replace author = "Douglas B. Bernheim" if author == "Douglas Bernheim"
	replace author = "In-Koo Cho" if author == "In K. Cho"
	replace author = "Jeffrey A. Miron" if author == "Jeffrey Miron"
	replace author = "John N. Friedman" if author == "John Friedman"
	replace author = "Kenneth D. West" if author == "Kenneth West"
	replace author = "Robert S. Gibbons" if author == "Robert Gibbons"
	replace author = "Reed W. Walker" if author == "Reed Walker"
	replace author_fellow = author 
	compress
	save "${root}/`field'/output/Sloan_fellows_clean.dta", replace
end

program EMA_lecture
	syntax, field(str)
	* Fisher-Schultz Lecture
	local field = "econ"
	import excel  "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Fisher-Schultz Lecture") firstrow clear

	drop affiliation title original
	rename (author_1 author_2) (author1 author2)

	* collapse to author-year level
	reshape long author, i(year)
	drop if missing(author)
	drop _j

	* clean up some names
	replace author = "Tjalling C. Koopmans" if author == "T.C. Koopmans"
	replace author = "Arthur S. Goldberger" if author == "A. Goldberger"
	replace author = "Robert F. Engle" if author == "Robert F. Engle III"
	replace author = "David E. Card" if author == "David Card"
	replace author = "Robert E. Lucas" if author == "Robert Lucas"

	save "${root}/`field'/input/raw/ECMA_lectures/FS_lecture.dta", replace

	* Jacob-Marschak Lecture
	import excel "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Jacob Marschak Lecture") firstrow clear

	drop title location city_country original
	drop if author == ""

	* clean up some names
	replace author = "Robert E. Lucas" if author == "Robert Lucas"
	replace author = "Hashem M. Pesaran" if author == "M. H. Pesaran"

	save "${root}/`field'/input/raw/ECMA_lectures/JM_lecture.dta", replace

	* Walras-Bowley Lecture
	import excel "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Walras-Bowley Lecture") firstrow clear

	drop title affiliation original
	rename name author
	replace author = strtrim(author)

	* clean up some names
	replace author = "Anthony B. Atkinson" if author == "A.B. Atkinson"
	replace author = "Carl Christian Von Weizsacker" if author == "C. Christian von Weizsacker"
	replace author = "Thirukodikaval N. Srinivasan" if author == "T.N. Srinivasan"
	replace author = "Edmond Malinvaud" if author == "E. Malinvaud"
	replace author = "Frank H. Hahn" if author == "F. H. Hahn"

	save "${root}/`field'/input/raw/ECMA_lectures/WB_lecture.dta", replace

	* Frisch Memorial Lecture
	import excel "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Frisch Memorial Lecture") firstrow clear

	drop affiliation original
	rename name author

	save "${root}/`field'/input/raw/ECMA_lectures/FM_lecture.dta", replace

	* Cowles Lecture
	import excel "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Cowles Lecture") firstrow clear

	drop affiliation original
	rename name author
	replace author = strtrim(author)

	save "${root}/`field'/input/raw/ECMA_lectures/C_lecture.dta", replace

	*** Merge the lectures together
	use "${root}/`field'/input/raw/ECMA_lectures/FS_lecture.dta", clear

	append using "${root}/`field'/input/raw/ECMA_lectures/JM_lecture.dta"
	append using "${root}/`field'/input/raw/ECMA_lectures/WB_lecture.dta"
	append using "${root}/`field'/input/raw/ECMA_lectures/FM_lecture.dta"
	append using "${root}/`field'/input/raw/ECMA_lectures/C_lecture.dta"

	order author year
	sort author year

	replace author = proper(author)

	
	* parse the names
	replace author = subinstr(author, " ", " ", .)
	
	name_parse
	merge m:1 author using "${root}/econ/output/replacement_names.dta", nogen keep(1 3) keepusing(replacement)
	replace author = replacement if replacement != ""
	replace author_fellow = replacement if replacement != ""
	drop replacement
	
	* take the earliest lecture
	bys author (year): keep if _n == 1

	replace author = subinstr(author, ".", ". ", .)
	replace author = stritrim(author)
	
	
	rename year year_appointed_EMALEC
	replace author = "Carl Christian Von Weizsacker" if author == "Carl C. Weizsacker"
	replace author = "Douglas M. Gale" if author == "Douglas Gale"
	replace author = "Lawrence R. Klein" if author == "Lawrence Klein"
	replace author = "Oliver D. Hart" if author == "Oliver Hart"
	replace author = "Robert B. Wilson" if author == "Robert Wilson"
	replace author = "Ronald A. Gallant" if author == "Ronald Gallant"
	replace author = "Stephen E. Morris" if author == "Stephen Morris"
	replace author = "Martin S. Eichenbaum" if author == "Martin Eichenbaum"
	replace author = "Clive W. J. Granger" if author == "Clive W. Granger"
	replace author = "Clive W. J. Granger" if author == "Clive Granger"
	replace author_fellow = author 
	
	* duplicate
	drop if author == "Dan Mcfadden"
	compress
	save "${root}/`field'/output/EMALEC_fellows_clean.dta", replace
end

main
