clear all 
set more off 
global root "PATH/TO/REPLICATION/"
cd "${root}"
global econ_paper "econ_Paper_Level_clean.dta"

program main
	foreach field in econ {
		use "${`field'_paper}", clear
		clean_special
		clean_title
	
		format %40s author

		compress
		save "${`field'_paper}", replace
	}
	* run match_fi_name.do next
end

program clean_special
	* below cleans special characters 
	replace author = subinstr(author, "’", "'", .)
	replace author = subinstr(author, " ", "'", .)
	replace author = subinstr(author, "{", "'", .)
	replace author = subinstr(author, "}", "'", .)
	
	replace author = subinstr(author, "Á", "A", .)
	replace author = subinstr(author, "Å", "A", .)
	replace author = subinstr(author, "Ä°", "A", .)
	replace author = subinstr(author, "Ä", "A", .)
	replace author = subinstr(author, "Ã", "A", .)
	replace author = subinstr(author, "Ā", "A", .)
	replace author = subinstr(author, "Ã", "A", .)
	replace author = subinstr(author, "Ã³", "A", .)
	replace author = subinstr(author, "å", "a", .)
	replace author = subinstr(author, "á", "a", .)
	replace author = subinstr(author, "à", "a", .)
	replace author = subinstr(author, "ä", "a", .)
	replace author = subinstr(author, "æ", "ae", .)
	replace author = subinstr(author, "ã", "a", .)
	replace author = subinstr(author, "â", "a", .)
	replace author = subinstr(author, "a¹", "a", .)
	replace author = subinstr(author, "a¶", "o", .)
	replace author = subinstr(author, "a¤", "a", .)
	replace author = subinstr(author, "ă", "a", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00a4"), "a") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00a4"), "a") 
	
	replace author = subinstr(author, "ß", "b", .)
	
	replace author = subinstr(author, "č", "c", .)
	replace author = subinstr(author, "ć", "c", .)
	replace author = subinstr(author, "c̆", "c", .)
	replace author = subinstr(author, "Ç", "C", .)
	replace author = subinstr(author, "ç", "c", .)
	replace author = subinstr(author, "¢", "c", .)
	replace author = subinstr(author, "Č", "C", .)
	replace author = subinstr(author, "©", "c", .)
	replace author = subinstr(author, "§", "c", .)
	
	replace author = subinstr(author, "É", "E", .)
	replace author = subinstr(author, "Ë", "E", .)
	replace author = subinstr(author, "é", "e", .)
	replace author = subinstr(author, "è", "e", .)
	replace author = subinstr(author, "ě", "e", .)
	replace author = subinstr(author, "ë", "e", .)
	replace author = subinstr(author, "ȩ", "e", .)
	replace author = subinstr(author, "ȩ", "e", .)
	replace author = subinstr(author, "ę", "e", .)
	
	replace author = subinstr(author, "ǧ", "g", .)
	replace author = subinstr(author, "ğ", "g", .)
	replace author = subinstr(author, "ǧ̃", "g", .)
	replace author = subinstr(author, "g̃", "g", .)
	replace author = subinstr(author, "gˇ", "g", .)
	replace author = subinstr(author, "Ğ", "g", .)
	replace author = subinstr(author, "ḡ", "g", .)
	
	replace author = subinstr(author, "ǐ", "I", .)
	replace author = subinstr(author, "İ", "I", .)
	replace author = subinstr(author, "Î", "I", .)
	replace author = subinstr(author, "Í", "I", .)
	replace author = subinstr(author, "Ì", "I", .)
	replace author = subinstr(author, "Ï", "I", .)
	replace author = subinstr(author, "Ï", "I", .)
	replace author = subinstr(author, "i̇", "i", .)
	replace author = subinstr(author, "ı̈", "i", .)
	replace author = subinstr(author, "ï", "i", .)
	replace author = subinstr(author, "ı¨", "i", .)
	replace author = subinstr(author, "ı́", "i", .)
	replace author = subinstr(author, "í", "i", .)
	replace author = subinstr(author, "ĭ", "i", .)
	replace author = subinstr(author, "iˇ", "i", .)
	replace author = subinstr(author, "iˆ", "i", .)
	replace author = subinstr(author, "ı", "i", .)
	replace author = subinstr(author, "î", "i", .)
	replace author = subinstr(author, "¡", "i", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00ad"), "i") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00ad"), "i") 
	
	replace author = subinstr(author, "Ł", "L", .)
	replace author = subinstr(author, "Ľ", "L", .)
	replace author = subinstr(author, "ł", "l", .)
	
	replace author = subinstr(author, "Ñ", "N", .)
	replace author = subinstr(author, "ń", "n", .)
	replace author = subinstr(author, "ñ", "n", .)
	
	replace author = subinstr(author, "Ø", "O", .)
	replace author = subinstr(author, "Ó", "O", .)
	replace author = subinstr(author, "Ö", "O", .)
	replace author = subinstr(author, "Ò", "O", .)
	replace author = subinstr(author, "Ō", "O", .)
	replace author = subinstr(author, "ö", "o", .)
	replace author = subinstr(author, "Ó", "O", .)
	replace author = subinstr(author, "ó", "o", .)
	replace author = subinstr(author, "ò", "o", .)
	replace author = subinstr(author, "ø", "o", .)
	replace author = subinstr(author, "ô", "o", .)
	replace author = subinstr(author, "ő", "o", .)
	replace author = subinstr(author, "œ", "oe", .)
	replace author = subinstr(author, "Œ", "oe", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00b6"), "o") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00b6"), "o") 
	
	replace author = subinstr(author, "ř", "r", .)
	
	replace author = subinstr(author, "š", "s", .)
	replace author = subinstr(author, "ş", "s", .)
	replace author = subinstr(author, "Š", "S", .)
	replace author = subinstr(author, "Ş", "S", .)
	replace author = subinstr(author, "Ś", "S", .)
	
	replace author = subinstr(author, "ü", "u", .)
	replace author = subinstr(author, "ú", "u", .)
	replace author = subinstr(author, "ü", "u", .)
	replace author = subinstr(author, "Ü", "U", .)
	replace author = subinstr(author, "Ú", "U", .)
	
	replace author = subinstr(author, "ý", "y", .)
	
	
	replace author = subinstr(author, "Ż", "Z", .)
	replace author = subinstr(author, "Ž", "Z", .)
	replace author = subinstr(author, "ž", "z", .)
	
	
	replace author = subinstr(author, " ", " ", .)
	replace author = subinstr(author, "–", "-", .)
	replace author = subinstr(author, "‐", "-", .)
	replace author = subinstr(author, "¨", "-", .)
end

program clean_title
	
	** remove titles of author names 
	** Note that the ones with leading whitespace must be last in order to remove 
	** all extraneous , ; etc.
	replace author = subinstr(author, "; Jr.", "", .)
	replace author = subinstr(author, ", Jr.", "", .)
	replace author = subinstr(author, ", Jr", "", .)
	replace author = subinstr(author, "Jr.,", "", .)
	replace author = subinstr(author, "; Jr", "", .)
	replace author = subinstr(author, " Jr.", "", .)
	replace author = subinstr(author, "Jr.", "", .)
	replace author = subinstr(author, "Jr", "", .)
	replace author = subinstr(author, "JR.", "", .)
	replace author = subinstr(author, "JR", "", .)
	replace author = subinstr(author, "JR", "", .)
	
	replace author = subinstr(author, ", II", "", .)
	replace author = subinstr(author, ", II.", "", .)
	replace author = subinstr(author, " II", "", .)
	
	replace author = subinstr(author, ", III", "", .)
	replace author = subinstr(author, ", III.", "", .)
	replace author = subinstr(author, " III", "", .)
		
	replace author = subinstr(author, "; 3rd", "", .)
	replace author = subinstr(author, " 3rd", "", .)
	
	replace author = subinstr(author, "*", "", .)
	replace author = subinstr(author, "†", "", .)
	replace author = subinstr(author, "DR ", "", .)
	replace author = subinstr(author, "Mr.", "", .)
	replace author = subinstr(author, "Mrs.", "", .)
	replace author = subinstr(author, "Prof.", "", .)
	replace author = subinstr(author, "Prof", "", .)
	replace author = subinstr(author, "Ph.D.", "", .)
	replace author = subinstr(author, "Ph. D.", "", .)
	replace author = subinstr(author, "PhD.", "", .)
	replace author = subinstr(author, "PH.D.", "", .)
	replace author = subinstr(author, "LL.B.", "", .)
	replace author = subinstr(author, "L.L.D.", "", .)
	replace author = subinstr(author, "S.B.", "", .)
	replace author = subinstr(author, "S. B.", "", .)
	replace author = subinstr(author, "M.D.", "", .)
	replace author = subinstr(author, "United States Commissioner of Labor", "", .)
	replace author = subinstr(author, "Superintendent of Census", "", .)
	replace author = subinstr(author, "A.M.", "", .)
	replace author = subinstr(author, "LL.D.", "", .)
	replace author = subinstr(author, "C.M.G.", "", .)
	replace author = subinstr(author, "M.S.", "", .)
	replace author = subinstr(author, "S.M.", "", .)
	replace author = subinstr(author, "Dr.", "", .)
	replace author = subinstr(author, "A. B.", "", .)
	replace author = subinstr(author, "AA. A.", "", .)
	replace author = subinstr(author, "C.P.A.", "", .)
	replace author = subinstr(author, "C. P. A.", "", .)
	replace author = subinstr(author, "C.P.H.", "", .)
	replace author = subinstr(author, "C. M. G.", "", .)
	replace author = subinstr(author, "O. B. E.", "", .)
	replace author = subinstr(author, "F.A.S.", "", .)
	replace author = subinstr(author, "F.A.I.A.", "", .)
	replace author = subinstr(author, "A.C.A.S.", "", .)
	replace author = subinstr(author, "D.Sc.", "", .)
	replace author = subinstr(author, "Sir", "", .)
	replace author = subinstr(author, "Editor", "", .)
	replace author = subinstr(author, "Secretary", "", .)
	replace author = subinstr(author, "Superintendent of Health", "", .)
	replace author = subinstr(author, "Registrar of Vital Statistics", "", .)
	replace author = subinstr(author, "Chief Health Officer", "", .)
	replace author = subinstr(author, "Registrar Of Records", "", .)
	replace author = subinstr(author, "Executive Secretary of the Commission", "", .)
	replace author = subinstr(author, "Director of the Census", "", .)
	replace author = subinstr(author, "Director of Census", "", .)
	replace author = subinstr(author, "Secretary to the Commission", "", .)
	replace author = subinstr(author, "Director of the Bureau of the Census", "", .)
	replace author = subinstr(author, "Assistant", "", .)
	replace author = subinstr(author, "President State Normal School", "", .)
	replace author = subinstr(author, "Editor of the Crisis Magazine", "", .)
	replace author = subinstr(author, "Statistician", "", .)
	replace author = subinstr(author, "Municipal", "", .)
	replace author = subinstr(author, "Anthropologist", "", .)
	replace author = subinstr(author, "Chairman of Provisional Committee", "", .)
	replace author = subinstr(author, "Economic Adviser to the  of Agriculture", "", .)
	replace author = subinstr(author, "Economic Advisor on Finance to the  of Agriculture", "", .)
	replace author = subinstr(author, "Executive  and Treasurer", "", .)
	replace author = subinstr(author, "Director-General of Statistics", "", .)
	replace author = subinstr(author, "Industrial Engineer", "", .)
	replace author = subinstr(author, "Vice President of the United States", "", .)
	replace author = subinstr(author, "Honorable", "", .)
	replace author = subinstr(author, "President", "", .)
	replace author = subinstr(author, "M.P.H.", "", .)
	replace author = subinstr(author, "SmithI ", "Smith", .)
	replace author = subinstr(author, "MerrillI", "Merrill", .)
	replace author = subinstr(author, "Graduate Student in Chemical Engineering", "", .)
	replace author = subinstr(author, "Private Consultant", "", .)
	replace author = subinstr(author, "Executive  of the Commission", "", .)
	replace author = subinstr(author, "to the Commission", "", .)
	replace author = subinstr(author, "of the Crisis Magazine", "", .)
	replace author = subinstr(author, "Consultant in statistics", "", .)
	replace author = subinstr(author, "The Multicenter Diltiazem Post-Infarction Trial Research Group", "", .)
	replace author = subinstr(author, "Associate essor", "", .)
	replace author = subinstr(author, "essor", "", .)
	replace author = subinstr(author, "and Senior Biostatistician", "", .)
	replace author = subinstr(author, "Committee on the National Science Foundation on the Economics ession", "", .)
	replace author = subinstr(author, "Review by: ", "", .)
	replace author = subinstr(author, "Editor's Choice", "", .)
	replace author = subinstr(author, "'s Choice", "", .)
	replace author = subinstr(author, "'S Choice", "", .)
	replace author = subinstr(author, "A Welfare Analysis", "", .)
	replace author = subinstr(author, "Commission of the Association of Collegiate Schools of Business", "", .)
	replace author = subinstr(author, "For The Alzheimer'S Disease Neuroimaging Initiative", "", .)
	replace author = subinstr(author, "Staff Of Social Sciences 125", "", .)
	replace author = subinstr(author, "Financial Research Program", "", .)
	replace author = subinstr(author, "Research Articles", "", .)
	replace author = subinstr(author, "Research Article", "", .)
	replace author = subinstr(author, "Social Research", "", .)
	replace author = subinstr(author, "National Institute Of Economic", "", .)
	replace author = subinstr(author, "             ", " ", .)
	replace author = subinstr(author, "³", "", .)
	replace author = subinstr(author, "²", "", .)
	replace author = subinstr(author, "¸", "", .)
	
	replace author = subinstr(author, ",", "", .)
	replace author = subinstr(author, " ;", ";", .)
	replace author = subinstr(author, ";  ", "; ", .)
	replace author = subinstr(author, "{", "", .)
	replace author = subinstr(author, "} ", "", .)
	replace author = strtrim(author)
	
	** proper names
	replace author = proper(author)
end

* EXECUTE 
main
