

clear all
set more off

global root "PATH/TO/REPLICATION/"
cd "${root}"
global econ_paper "econ_Paper_Level_clean.dta"

program main
	AEA_pres 
	AEA_vp
	asso_editor
	editor
	coeditor
end



program clean_special
	replace author = subinstr(author, "’", "'", .)
	
	replace author = subinstr(author, "Á", "A", .)
	replace author = subinstr(author, "Å", "A", .)
	replace author = subinstr(author, "Ä°", "A", .)
	replace author = subinstr(author, "Ä", "A", .)
	replace author = subinstr(author, "Ã", "A", .)
	replace author = subinstr(author, "Ā", "A", .)
	replace author = subinstr(author, "Ã", "A", .)
	replace author = subinstr(author, "Ã³", "A", .)
	replace author = subinstr(author, "å", "a", .)
	replace author = subinstr(author, "á", "a", .)
	replace author = subinstr(author, "à", "a", .)
	replace author = subinstr(author, "ä", "a", .)
	replace author = subinstr(author, "æ", "ae", .)
	replace author = subinstr(author, "ã", "a", .)
	replace author = subinstr(author, "â", "a", .)
	replace author = subinstr(author, "a¹", "a", .)
	replace author = subinstr(author, "a¶", "o", .)
	replace author = subinstr(author, "a¤", "a", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00a4"), "a") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00a4"), "a") 
	
	replace author = subinstr(author, "ß", "b", .)
	
	replace author = subinstr(author, "č", "c", .)
	replace author = subinstr(author, "ć", "c", .)
	replace author = subinstr(author, "c̆", "c", .)
	replace author = subinstr(author, "Ç", "C", .)
	replace author = subinstr(author, "ç", "c", .)
	replace author = subinstr(author, "¢", "c", .)
	replace author = subinstr(author, "Č", "C", .)
	replace author = subinstr(author, "©", "c", .)
	replace author = subinstr(author, "§", "c", .)
	
	replace author = subinstr(author, "É", "E", .)
	replace author = subinstr(author, "Ë", "E", .)
	replace author = subinstr(author, "é", "e", .)
	replace author = subinstr(author, "è", "e", .)
	replace author = subinstr(author, "ě", "e", .)
	replace author = subinstr(author, "ë", "e", .)
	replace author = subinstr(author, "ȩ", "e", .)
	
	replace author = subinstr(author, "ǧ", "g", .)
	replace author = subinstr(author, "ğ", "g", .)
	replace author = subinstr(author, "ǧ̃", "g", .)
	replace author = subinstr(author, "g̃", "g", .)
	replace author = subinstr(author, "gˇ", "g", .)
	replace author = subinstr(author, "Ğ", "g", .)
	replace author = subinstr(author, "ḡ", "g", .)
	
	replace author = subinstr(author, "İ", "I", .)
	replace author = subinstr(author, "Î", "I", .)
	replace author = subinstr(author, "Í", "I", .)
	replace author = subinstr(author, "Ì", "I", .)
	replace author = subinstr(author, "Ï", "I", .)
	replace author = subinstr(author, "i̇", "i", .)
	replace author = subinstr(author, "ı̈", "i", .)
	replace author = subinstr(author, "ï", "i", .)
	replace author = subinstr(author, "ı¨", "i", .)
	replace author = subinstr(author, "ı́", "i", .)
	replace author = subinstr(author, "í", "i", .)
	replace author = subinstr(author, "ĭ", "i", .)
	replace author = subinstr(author, "iˇ", "i", .)
	replace author = subinstr(author, "iˆ", "i", .)
	replace author = subinstr(author, "ı", "i", .)
	replace author = subinstr(author, "î", "i", .)
	replace author = subinstr(author, "¡", "i", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00ad"), "i") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00ad"), "i") 
	
	replace author = subinstr(author, "Ł", "L", .)
	replace author = subinstr(author, "Ľ", "L", .)
	replace author = subinstr(author, "ł", "l", .)
	
	replace author = subinstr(author, "Ñ", "N", .)
	replace author = subinstr(author, "ń", "n", .)
	replace author = subinstr(author, "ñ", "n", .)
	
	replace author = subinstr(author, "Ø", "O", .)
	replace author = subinstr(author, "Ó", "O", .)
	replace author = subinstr(author, "Ö", "O", .)
	replace author = subinstr(author, "Ò", "O", .)
	replace author = subinstr(author, "Ō", "O", .)
	replace author = subinstr(author, "ö", "o", .)
	replace author = subinstr(author, "Ó", "O", .)
	replace author = subinstr(author, "ó", "o", .)
	replace author = subinstr(author, "ò", "o", .)
	replace author = subinstr(author, "ø", "o", .)
	replace author = subinstr(author, "ô", "o", .)
	replace author = subinstr(author, "ő", "o", .)
	replace author = subinstr(author, "œ", "oe", .)
	replace author = subinstr(author, "Œ", "oe", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00b6"), "o") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00b6"), "o") 
	
	replace author = subinstr(author, "ř", "r", .)
	
	replace author = subinstr(author, "š", "s", .)
	replace author = subinstr(author, "ş", "s", .)
	replace author = subinstr(author, "Š", "S", .)
	replace author = subinstr(author, "Ş", "S", .)
	replace author = subinstr(author, "Ś", "S", .)
	
	replace author = subinstr(author, "ü", "u", .)
	replace author = subinstr(author, "ú", "u", .)
	replace author = subinstr(author, "ü", "u", .)
	replace author = subinstr(author, "Ü", "U", .)
	replace author = subinstr(author, "Ú", "U", .)
	
	replace author = subinstr(author, "ý", "y", .)
	
	replace author = subinstr(author, "Ž", "Z", .)
	replace author = subinstr(author, "ž", "z", .)
	
	
	replace author = subinstr(author, " ", " ", .)
	replace author = subinstr(author, "–", "-", .)
	replace author = subinstr(author, "‐", "-", .)
	replace author = subinstr(author, "¨", "-", .)
end

program name_parse
	* parse the names
	split author, parse(" ")
	local nsplit = r(nvars)
	gen last_name = ""
	forval y = 1/`nsplit' {
		replace last_name = author`y' if !missing(author`y')
	}

	rename author1 first_name

	gen middle_name = ""
	forval y = 2/`nsplit' {
		replace middle_name = middle_name + " " + author`y' if !missing(author`y') & author`y' != last_name
	}
	replace middle_name = strtrim(middle_name)

	* change x. xxx xxx into xxx x. xxx
	gen fi = first_name
	replace first_name = middle_name if ustrregexm(first_name, "^[A-Z]\.")==1 & ustrregexm(middle_name, "[A-Za-z]\.") == 0 & lower(middle_name) != "de" & lower(middle_name) != "van" & lower(middle_name) != "von" & lower(middle_name) != "la" & middle_name != ""

	* change middle names to first initials 
	replace middle_name = substr(middle_name, 1, 1) + "." if strlen(middle_name) > 2 & strpos(middle_name, ".") == 0

	replace middle_name = fi if author2 == first_name

	gen author_full = first_name + " " + middle_name + " " + last_name if middle_name != ""
	drop fi author2-author`nsplit'
	
	order author first_name middle_name last_name year

	* generate variables to match
	gen author_nomi = first_name + " " + last_name
	replace author_full = author_nomi if author_full == ""

	gen author_fellow = author_full

	replace author_fellow = proper(author_fellow)
	replace author_full = proper(author_full)

	drop author first_name middle_name
end


program AEA_pres
	*** clean the AEA President 

	import delimited "${root}/econ/input/raw/aea_president.csv",encoding(UTF-8)clear

	* split string 
	replace v1 = strtrim(v1)
	split v1, p(",")
	rename v11 author 
	rename v12 institute 
	rename v13 year_appointed 
	replace year_appointed = "1981" if author == "WILLIAM J. BAUMOL"
	replace year_appointed = "2002" if author == "ROBERT E. LUCAS"
	replace year_appointed = "2001" if author == "SHERWIN ROSEN"
	replace institute = "Chicago" if author == "ROBERT E. LUCAS"
	replace author = "ROBERT E. LUCAS JR." if author == "ROBERT E. LUCAS"
	replace author = "FRANCIS A. WALKER" if strpos(author, "FRANCIS A. WALKER")
	replace year_appointed = "1886-92" if author == "FRANCIS A. WALKER"
	replace year_appointed = "1978" if author == "JACOB MARSCHAK"

	* clean term date 
	split year_appointed, p("-")
	rename year_appointed1 term_date1 
	rename year_appointed2 term_date2
	replace term_date2 = "." if term_date2 == ""
	replace term_date2 = substr(term_date1, 1, 2) + term_date2 if term_date2 != "."
	drop institute v14 v1 year_appointed 

	clean_special

	* clean author name 
	split author, p(" ")
	gen lastname = "."

	replace lastname = author2 if missing(author3) & missing(author4)
	replace lastname = author3 if missing(author4) & lastname == "."
	replace lastname = author4 if lastname == "."

	rename author1 firstname
	rename author2 middle_name1
	rename author3 middle_name2

	replace middle_name1 = "" if middle_name1 == lastname
	replace middle_name2 = "" if middle_name2 == lastname

	drop author4

	replace firstname = substr(firstname, 1, 1) + lower(substr(firstname, 2, length(firstname)-1))
	replace middle_name1 = substr(middle_name1, 1, 1) + lower(substr(middle_name1, 2, length(middle_name1)-1))
	replace middle_name2 = substr(middle_name2, 1, 1) + lower(substr(middle_name2, 2, length(middle_name2)-1))
	replace lastname = substr(lastname, 1, 1) + lower(substr(lastname, 2, length(lastname)-1))

	gen new_author = ""
	gen author_nomi = ""
	replace new_author = firstname + " " + lastname if middle_name1 == "" & middle_name2 == ""
	replace new_author = firstname + " " + middle_name1 + " " + lastname if middle_name1 != "" & middle_name2 == ""
	replace new_author = firstname + " " + middle_name1 + " " + middle_name2 + " " + lastname if new_author == ""
	replace author_nomi = firstname + " " + lastname 
	replace author = new_author
	drop new_author firstname lastname middle_name1 middle_name2 
	order author author_nomi term_date1 term_date2

	gen year1 = term_date1
	gen year2 = term_date2
	destring term_date1 term_date2, replace

	reshape long year, i(author)
	drop _j
	order author year
	sort year author 
	destring year, replace
	drop if year == .

	egen id = group(author)
	tsset id year
	tsfill, full
	list, clean noobs

	local varlist author author_nomi term_date1 term_date2 
	foreach var in `varlist' {
		bysort id: carryforward `var', gen(`var'_ex)
		drop `var'
		rename `var'_ex `var'
	}

	drop if term_date1 == .
	drop if year > term_date2 & term_date2 != .
	drop if year > term_date1 & term_date2 == .
	order author author_nomi year 
	sort year
	drop term_date1 term_date2 id

	replace author = "Gale D. Johnson" if author == "D. Gale Johnson"
	replace author_nomi = "Gale Johnson" if author_nomi == "D. Johnson"
	replace author = "Leo I. Sharfman" if author == "I. L. Sharfman"
	replace author_nomi = "Leo Sharfman" if author_nomi == "I. Sharfman"
	replace author = "Jakob Marschak" if author == "Jacob Marschak"
	replace author_nomi = "Jakob Marschak" if author_nomi == "Jacob Marschak"
	replace author = "O. M. W. Sprague" if author == "Oliver M. W. Sprague"
	replace author_nomi = "O. Sprague" if author_nomi == "Oliver Sprague"
	replace author = "Arthur W. Lewis" if author == "W. Arthur Lewis"
	replace author_nomi = "Arthur Lewis" if author_nomi == "W. Lewis"
	replace author = "Henry Walcott Farnam" if author == "H. W. Farnam"
	replace author_nomi = "Henry Farnam" if author_nomi == "H. Farnam"
	replace author = "Emanuel Goldenweiser" if author == "E. Goldenweiser"
	replace author_nomi = "Emanuel Goldenweiser" if author_nomi == "E. Goldenweiser"
	
	replace author = "Angus S. Deaton" if author == "Angus Deaton"
	replace author = "Arthur Twining Hadley" if author == "Arthur T. Hadley"
	replace author = "Claudia Dale Goldin" if author == "Claudia Goldin"
	replace author = "Daniel L. Mcfadden" if author == "Daniel Mcfadden"
	replace author = "Edwin Walter Kemmerer" if author == "Edwin W. Kemmerer"
	replace author = "Thomas Carver" if author == "Thomas N. Carver"
	replace author = "Orley C. Ashenfelter" if author == "Orley Ashenfelter"
	replace author = "Martin S. Feldstein" if author == "Martin Feldstein"
	replace author = "Olivier Jean Blanchard" if author == "Olivier Blanchard"
	replace author = "Richard H. Thaler" if author == "Richard Thaler"
	replace author = "Robert A. Gordon" if author == "Robert Gordon"
	replace author = "Robert J. Shiller" if author == "Robert Shiller"
	replace author = "Thomas Nixon Carver" if author == "Thomas Carver"
	replace author = "Wassily Wassilyevich Leontief" if author == "Wassily Leontief"
	replace author = "William S. Vickrey" if author == "William Vickrey"
	replace author = "George Ward Stocking" if author == "George W. Stocking"
	replace author = "Robert E. Lucas" if author == "Robert E. Lucas Jr."
	replace author = "Robert William Fogel" if author == "Robert W. Fogel"
	replace author = "Henry Walcott Farnam" if author == "Henry W. Farnam"
	replace author = "Amartya Kumar Sen" if author == "Amartya Sen"
	replace author = "Frank Albert Fetter" if author == "Frank A. Fetter"
	replace author = "Gottfried Von Haberler" if author == "Gottfried Haberler"
	replace author = "Henry Rogers Seager" if author == "Henry R. Seager"
	replace author = "John Maurice Clark" if author == "John M. Clark"
	replace author = "Morris Albert Copeland" if author == "Morris A. Copeland"
	replace author = "Oliver M. W. Sprague" if author == "O. M. W. Sprague"
	replace author = "Paul Howard Douglas" if author == "Paul H. Douglas"
	replace author = "Simon S. Kuznets" if author == "Simon Kuznets"

	bys author (year): keep if _n == 1
	sort year
	compress
	save "${root}/econ/temp/aea_president_clean.dta", replace
end

program AEA_vp
	*** clean the AEA Vice President 
	import delimited "${root}/econ/input/raw/aea_vp.csv",encoding(UTF-8)clear
	* split string 
	replace v1 = strtrim(v1)
	split v1, p(",")
	rename v11 author 
	rename v12 year  
	replace year = "1949" if strpos(author, "THEODORE W. SCHULTZ")
	replace year = "1987" if author == "ROBERT E. LUCAS"
	replace author = "THEODORE W. SCHULTZ" if strpos(author, "THEODORE W. SCHULTZ")
	destring year, replace 

	clean_special

	* clean author name 
	split author, p(" ")
	gen lastname = "."

	replace lastname = author2 if missing(author3)
	replace lastname = author3 if lastname == "."
	rename author1 firstname
	rename author2 middle_name1
	rename author3 middle_name2

	replace middle_name1 = "" if middle_name1 == lastname
	replace middle_name2 = "" if middle_name2 == lastname

	drop middle_name2

	replace firstname = substr(firstname, 1, 1) + lower(substr(firstname, 2, length(firstname)-1))
	replace middle_name1 = substr(middle_name1, 1, 1) + lower(substr(middle_name1, 2, length(middle_name1)-1))
	replace lastname = substr(lastname, 1, 1) + lower(substr(lastname, 2, length(lastname)-1))

	gen new_author = ""
	gen author_nomi = ""
	replace new_author = firstname + " " + lastname if middle_name1 == ""
	replace new_author = firstname + " " + middle_name1 + " " + lastname if middle_name1 != "" & new_author == ""
	replace author_nomi = firstname + " " + lastname 
	replace author = new_author
	drop new_autho firstname lastname middle_name1 v1 
	sort year 

	order author author_nomi year 

	* Handchecked replacements to fix next merge with partial matches
	replace author = "Frederic M. Scherer" if author == "F. M. Scherer"
	replace author = "Gregg H. Lewis" if author == "H. Gregg Lewis"
	replace author = "Hendrik S. Houthakker" if author == "Hendrik S. Houthaker"
	replace author = "Rudi Dornbusch" if author == "Rudiger W. Dornbusch"
	replace author = "Arthur W. Lewis" if author == "W. Arthur Lewis"
	replace author = "Katherine G. Abraham" if author == "Katharine Abraham"
	replace author = "Gregory N. Mankiw" if author == "N. Gregory Mankiw" 
	
	replace author = "Albert Gailord Hart" if author == "Albert G. Hart"
	replace author = "Avinash K. Dixit" if author == "Avinash Dixit"
	replace author = "Carl F. Christ" if author == "Carl Christ"
	replace author = "Cecilia Elena Rouse" if author == "Cecilia E. Rouse"
	replace author = "Claudia Dale Goldin" if author == "Claudia D. Goldin"
	replace author = "David E. Card" if author == "David Card"
	replace author = "Edward F. Denison" if author == "Edward Denison"
	replace author = "Francine D. Blau" if author == "Francine Blau"
	replace author = "Henry J. Aaron" if author == "Henry Aaron"
	replace author = "Irma G. Adelman" if author == "Irma Adelman"
	replace author = "Jagdish N. Bhagwati" if author == "Jagdish Bhagwati"
	replace author = "Janet M. Currie" if author == "Janet Currie"
	replace author = "Janet L. Yellen" if author == "Janet Yellen"
	replace author = "Jonathan R. Eaton" if author == "Jonathan Eaton"
	replace author = "Juanita Kreps" if author == "Juanita M. Kreps"
	replace author = "Katharine G. Abraham" if author == "Katherine G. Abraham"
	replace author = "Lester C. Thurow" if author == "Lester Thurow"
	replace author = "Oliver D. Hart" if author == "Oliver Hart"
	replace author = "Olivier Jean Blanchard" if author == "Olivier J. Blanchard"
	replace author = "Pinelopi Koujianou Goldberg" if author == "Pinelopi Goldberg"
	replace author = "Richard Abel Musgrave" if author == "Richard A. Musgrave"
	replace author = "Richard H. Thaler" if author == "Richard H Thaler"
	replace author = "Susan C. Athey" if author == "Susan Athey"
	replace author = "Tjalling C. Koopmans" if author == "Tjalling Koopmans"
	replace author = "Wassily Wassilyevich Leontief" if author == "Wassily Leontief"
	replace author = "James S. Duesenberry" if author == "James Duesenberry"
	replace author = "Daron K. Acemoglu" if author == "Daron Acemoglu"
	replace author = "Andrew Felton Brimmer" if author == "Andrew F. Brimmer"
	replace author = "Edmund Strother Phelps" if author == "Edmund S. Phelps"
	replace author = "Gottfried Von Haberler" if author == "Gottfried Haberler"
	replace author = "Juanita M. Kreps" if author == "Juanita Kreps"
	replace author = "Richard Allen Lester" if author == "Richard A. Lester"
	replace author = "Richard Barry Freeman" if author == "Richard B. Freeman"
	replace author = "June E. O'Neill" if author == "June E. O'neill"
	replace author = "Robert Aaron Gordon" if author == "Robert A. Gordon"
	
	compress
	save "${root}/econ/temp/aea_vp_clean.dta", replace
end


program asso_editor 
	* associate editor
	insheet using "${root}/econ/input/raw/asso_editor.csv", name clear


	replace firstname = subinstr(firstname, "-", "-", .)
	replace lastname = subinstr(lastname, "ä", "a", .)
	replace lastname = subinstr(lastname, "ï", "i", .)
	replace lastname = subinstr(lastname, "ö", "o", .)
	replace firstname = subinstr(firstname, "á", "a", .)

	replace firstname = "Donald W. K." if firstname == "Donald W.K."
	replace firstname = "Douglas B." if firstname == "B. Douglas"
	replace firstname = "V. V." if firstname == "V.V."
	replace firstname = "G. S." if firstname == "G.S."
	replace firstname = "Peter J." if firstname == "J. Peter"
	replace firstname = "Hashem M." if firstname == "M. Hashem"
	replace firstname = "Richard J." if firstname == "J. Richard"
	replace firstname = "Dudley T." if firstname == "T. Dudley"
	replace firstname = "John D." if firstname == "D. John"

	gen asso_editor = firstname + " " + lastname
	drop lastname firstname
	order asso_editor

	split termdate, parse("-")
	gen year1 = termdate1
	gen year2 = termdate2
	destring termdate1 termdate2, replace

	gen dupe = (asso_editor[_n]==asso_editor[_n-1])
	preserve
		keep if dupe == 1
		reshape long year, i(asso_editor)
		drop termdate _j
		order asso_editor year
		destring year, replace
		drop if year == .
		
		egen id = group(asso_editor)
		tsset id year
		tsfill, full

		local varlist asso_editor termdate1 termdate2
		foreach var in `varlist' {
			bysort id: carryforward `var', gen(`var'_ex)
			drop `var'
			rename `var'_ex `var'
		}

		drop if termdate1 == .
		drop if year > termdate2
		order asso_editor year
		drop termdate1 termdate2 id
		
		tempfile multiterm
		save "`multiterm'"
	restore

	keep if dupe == 0
	reshape long year, i(asso_editor)
	drop termdate _j
	order asso_editor year
	destring year, replace
	drop if year == .

	egen id = group(asso_editor)
	tsset id year
	tsfill, full

	local varlist asso_editor termdate1 termdate2
	foreach var in `varlist' {
		bysort id: carryforward `var', gen(`var'_ex)
		drop `var'
		rename `var'_ex `var'
	}

	drop if termdate1 == .
	drop if year > termdate2
	order asso_editor year
	drop termdate1 termdate2 id
	append using "`multiterm'"

	sort asso_editor year

	replace asso_editor = subinstr(asso_editor, "ö", "o", .)

	replace asso_editor = "Angus S. Deaton" if asso_editor == "Angus Deaton"
	replace asso_editor = "Hugo F. Sonnenschein" if asso_editor == "Hugo Sonnenschein"
	replace asso_editor = "David E. Card" if asso_editor == "David Card"
	replace asso_editor = "Andrew W. Postlewaite" if asso_editor == "Andrew Postlewaite"
	replace asso_editor = "Christopher A. Sims" if asso_editor == "Christopher Sims"
	replace asso_editor = "David M. Kreps" if asso_editor == "David Kreps"
	replace asso_editor = "Douglas M. Gale" if asso_editor == "Douglas Gale"
	replace asso_editor = "Edmond Malinvaud" if asso_editor == "Edmond C. Malinvaud"
	replace asso_editor = "Harald F. Uhlig" if asso_editor == "Harald Uhlig"
	replace asso_editor = "Jacques H. Dreze" if asso_editor == "Jacques Dreze"
	replace asso_editor = "James A. Mirrlees" if asso_editor == "James A. Mirrlees"
	replace asso_editor = "Joel L. Horowitz" if asso_editor == "Joel Horowitz"
	replace asso_editor = "Kenneth F. Wallis" if asso_editor == "Kenneth Wallis"
	replace asso_editor = "Martin F. Hellwig" if asso_editor == "Martin Hellwig"
	replace asso_editor = "Menahem E. Yaari" if asso_editor == "Menahem Yaari"
	replace asso_editor = "Nancy L. Stokey" if asso_editor == "Nancy Stokey"
	replace asso_editor = "Peter M. Robinson" if asso_editor == "Peter Robinson"
	replace asso_editor = "Richard W. Blundell" if asso_editor == "Richard Blundell"
	replace asso_editor = "Robert H. Porter" if asso_editor == "Robert Porter"
	replace asso_editor = "Steven T. Berry" if asso_editor == "Steven Berry"
	replace asso_editor = "Bruce E. Hansen" if asso_editor == "Bruce E Hansen"
	replace asso_editor = "Gangadharrao S. Maddala" if asso_editor == "G. S. Maddala"
	replace asso_editor = "Andrew Mclennan" if asso_editor == "Andrew McLennan"
	replace asso_editor = "Barton L. Lipman" if asso_editor == "Bart Lipman"
	replace asso_editor = "Ben Polak" if asso_editor == "Benjamin Polak"
	replace asso_editor = "Christopher R. Udry" if asso_editor == "Chris Udry"
	replace asso_editor = "David Levine" if asso_editor == "David Levien"
	replace asso_editor = "Georges-Theodule Guilbaud" if asso_editor == "Georges Guilbaud"
	replace asso_editor = "Harold T. Davis" if asso_editor == "Harold Davis"
	replace asso_editor = "Jean-Charles C. Rochet" if asso_editor == "Jean Charles Rochet"
	replace asso_editor = "Donald John Roberts" if asso_editor == "John D. Roberts"
	replace asso_editor = "Martin J. Beckmann" if asso_editor == "Martin Beckmann"
	replace asso_editor = "Richard Stone" if asso_editor == "Richard J. Stone"
	replace asso_editor = "Thomas E. Macurdy" if asso_editor == "Thomas MaCurdy"
	replace asso_editor = "Varadarajan V. Chari" if asso_editor == "V. V. Chari"
	replace asso_editor = "Wilhelm E. Krelle" if asso_editor == "Wilhelm Krelle"
	replace asso_editor = "William M. T. Gorman" if asso_editor == "William Moore Gorman"
	replace asso_editor = "Adrian R. Pagan" if asso_editor == "Adrian Pagan"
	replace asso_editor = "Alan S. Manne" if asso_editor == "Alan Manne"
	replace asso_editor = "Alvin H. Hansen" if asso_editor == "Alvin Hansen"
	replace asso_editor = "Anton P. Barten" if asso_editor == "Anton Barten"
	replace asso_editor = "Avinash K. Dixit" if asso_editor == "Avinash Dixit"
	replace asso_editor = "Azeem M. Shaikh" if asso_editor == "Azeem Shaikh"
	replace asso_editor = "Bas J. M. Werker" if asso_editor == "Bas Werker"
	replace asso_editor = "Bo E. Honore" if asso_editor == "Bo Honore"
	replace asso_editor = "Charles F. Manski" if asso_editor == "Charles Manski"
	replace asso_editor = "Charles H. Whiteman" if asso_editor == "Charles Whiteman"
	replace asso_editor = "Christopher R. Taber" if asso_editor == "Christopher Taber"
	replace asso_editor = "Colin F. Camerer" if asso_editor == "Colin Camerer"
	replace asso_editor = "David F. Hendry" if asso_editor == "David Hendry"
	replace asso_editor = "Deborah J. Lucas" if asso_editor == "Deborah Lucas"
	replace asso_editor = "Denis Chetverikov" if asso_editor == "Dennis Chetverikov"
	replace asso_editor = "Edward E. Leamer" if asso_editor == "Edward Leamer"
	replace asso_editor = "Edward J. Vytlacil" if asso_editor == "Edward Vytlacil"
	replace asso_editor = "Francis X. Diebold" if asso_editor == "Francis Diebold"
	replace asso_editor = "Frederick C. Mills" if asso_editor == "Frederick Mills"
	replace asso_editor = "Geoffrey M. Heal" if asso_editor == "Geoffrey Heal"
	replace asso_editor = "George E. Tauchen" if asso_editor == "George Tauchen"
	replace asso_editor = "Gerald H. Kramer" if asso_editor == "Gerald Kramer"
	replace asso_editor = "Grant H. Hillier" if asso_editor == "Grant Hillier"
	replace asso_editor = "Guido W. Imbens" if asso_editor == "Guido Imbens"
	replace asso_editor = "Guillaume R. Frechette" if asso_editor == "Guillaume Frechette"
	replace asso_editor = "Haluk I. Ergin" if asso_editor == "Haluk Ergin"
	replace asso_editor = "Hanno N. Lustig" if asso_editor == "Hanno Lustig"
	replace asso_editor = "Hendrik S. Houthakker" if asso_editor == "Hendrik Houthakker"
	replace asso_editor = "Herbert E. Scarf" if asso_editor == "Herbert Scarf"
	replace asso_editor = "Herbert A. Simon" if asso_editor == "Herbert Simon"
	replace asso_editor = "Herman J. Bierens" if asso_editor == "Herbert Bierens"
	replace asso_editor = "Herman O. A. Wold" if asso_editor == "Herman Wold"
	replace asso_editor = "Ilya R. Segal" if asso_editor == "Ilya Segal"
	replace asso_editor = "Jaap H. Abbring" if asso_editor == "Jaap Abbbring"
	replace asso_editor = "James W. Friedman" if asso_editor == "James Friedman"
	replace asso_editor = "James L. Powell" if asso_editor == "James Powell"
	replace asso_editor = "James H. Stock" if asso_editor == "James Stock"
	replace asso_editor = "Jeffrey C. Ely" if asso_editor == "Jeffrey Ely"
	replace asso_editor = "Jerry R. Green" if asso_editor == "Jerry Green"
	replace asso_editor = "Jerry A. Hausman" if asso_editor == "Jerry Hausman"
	replace asso_editor = "John S. Chipman" if asso_editor == "John Chipman"
	replace asso_editor = "John F. Geweke" if asso_editor == "John Geweke"
	replace asso_editor = "John R. Hicks" if asso_editor == "John Hicks"
	replace asso_editor = "John Denis Sargan" if asso_editor == "John Sargan"
	replace asso_editor = "John B. Taylor" if asso_editor == "John Taylor"
	replace asso_editor = "Jorgen W. Weibull" if asso_editor == "Jorgen Weibull"
	replace asso_editor = "Joseph G. Altonji" if asso_editor == "Joseph Altonji"
	replace asso_editor = "Joseph A. Schumpeter" if asso_editor == "Joseph Schumpeter"
	replace asso_editor = "Joshua D. Angrist" if asso_editor == "Joshua Angrist"
	replace asso_editor = "Julio J. Rotemberg" if asso_editor == "Julio Rotemberg"
	replace asso_editor = "Juuso Valimaki" if asso_editor == "Juuso Vaimaki"
	replace asso_editor = "Kenneth O. May" if asso_editor == "Kenneth May"
	replace asso_editor = "Kenneth J. Singleton" if asso_editor == "Kenneth Singleton"
	replace asso_editor = "Kenneth D. West" if asso_editor == "Kenneth West"
	replace asso_editor = "Kenneth I. Wolpin" if asso_editor == "Kenneth Wolpin"
	replace asso_editor = "Larry E. Jones" if asso_editor == "Larry Jones"
	replace asso_editor = "Lawrence R. Klein" if asso_editor == "Lawrence Klein"
	replace asso_editor = "Lee E. Ohanian" if asso_editor == "Lee Ohanian"
	replace asso_editor = "Manuel S. Santos" if asso_editor == "Manuel Santos"
	replace asso_editor = "Marciano M. Siniscalchi" if asso_editor == "Marciano Siniscalchi"
	replace asso_editor = "Marilda A. De Oliveira Sotomayor" if asso_editor == "Marilda Sotomayor"
	replace asso_editor = "Mark J. Machina" if asso_editor == "Mark Machina"
	replace asso_editor = "Mark W. Watson" if asso_editor == "Mark Watson"
	replace asso_editor = "Martin J. Browning" if asso_editor == "Martin Browning"
	replace asso_editor = "Matias D. Cattaneo" if asso_editor == "Matias Cattaneo"
	replace asso_editor = "Michael P. Keane" if asso_editor == "Michael Keane"
	replace asso_editor = "Michael C. Lovell" if asso_editor == "Michael Lovell"
	replace asso_editor = "Nancy L. Schwartz" if asso_editor == "Nancy Schwartz"
	replace asso_editor = "Oliver D. Hart" if asso_editor == "Oliver Hart"
	replace asso_editor = "Oliver B. Linton" if asso_editor == "Oliver Linton"
	replace asso_editor = "Parag A. Pathak" if asso_editor == "Parag Pathak"
	replace asso_editor = "Peter C. Fishburn" if asso_editor == "Peter Fishburn"
	replace asso_editor = "Peter W. Howitt" if asso_editor == "Peter Howitt"
	replace asso_editor = "Peter J. Klenow" if asso_editor == "Peter J. Klenow"
	replace asso_editor = "Peter C. B. Phillips" if asso_editor == "Peter Phillips"
	replace asso_editor = "Peter C. Reiss" if asso_editor == "Peter Reiss"
	replace asso_editor = "Quang H. Vuong" if asso_editor == "Quang Vuong"
	replace asso_editor = "Raymond J. Deneckere" if asso_editor == "Raymond Deneckere"
	replace asso_editor = "Richard E. Quandt" if asso_editor == "Richard Quandt"
	replace asso_editor = "Robert J. Aumann" if asso_editor == "Robert Aumann"
	replace asso_editor = "Robert J. Barro" if asso_editor == "Robert Barro"
	replace asso_editor = "Robert A. Becker" if asso_editor == "Robert Becker"
	replace asso_editor = "Robert F. Engle" if asso_editor == "Robert Engle"
	replace asso_editor = "Robert E. Hall" if asso_editor == "Robert Hall"
	replace asso_editor = "Robert M. Solow" if asso_editor == "Robert Solow"
	replace asso_editor = "Roger H. Gordon" if asso_editor == "Roger Gordon"
	replace asso_editor = "Roger W. Koenker" if asso_editor == "Roger Koenker"
	replace asso_editor = "Rolf R. Mantel" if asso_editor == "Rolf Mantel"
	replace asso_editor = "Stefan G. N. Hoderlein" if asso_editor == "Stefan Hoderlein"
	replace asso_editor = "Stephen J. Redding" if asso_editor == "Stephen Redding"
	replace asso_editor = "Tomasz Strzalecki" if asso_editor == "Strzalecki Tomasz"
	replace asso_editor = "Thomas R. Palfrey" if asso_editor == "Thomas Palfrey"
	replace asso_editor = "Thomas M. Stoker" if asso_editor == "Thomas Stoker"
	replace asso_editor = "Tjalling C. Koopmans" if asso_editor == "Tjalling Koopmans"
	replace asso_editor = "Truman F. Bewley" if asso_editor == "Truman Bewley"
	replace asso_editor = "Victor M. Polterovich" if asso_editor == "Victor Polterovich"
	replace asso_editor = "Vincent P. Crawford" if asso_editor == "Vincent Crawford"
	replace asso_editor = "Whitney K. Newey" if asso_editor == "Whitney Newey"
	replace asso_editor = "William R. Zame" if asso_editor == "William Zame"
	replace asso_editor = "Yuzo Hosoya" if asso_editor == "Yuzo Hosova"
	replace asso_editor = "Amartya Kumar Sen" if asso_editor == "Amartya Sen"
	replace asso_editor = "David A. Easley" if asso_editor == "David Easley"
	replace asso_editor = "Giorgio E. Primiceri" if asso_editor == "Giorgio Primiceri"
	replace asso_editor = "Herman J. Bierens" if asso_editor == "Herman Bierens"
	replace asso_editor = "Matthew O. Jackson" if asso_editor == "Matthew Jackson"
	replace asso_editor = "Paul R. Milgrom" if asso_editor == "Paul Milgrom"
	replace asso_editor = "Peter J. Klenow" if asso_editor == "Peter Klenow"
	replace asso_editor = "Beth E. Allen" if asso_editor == "Beth Allen"
	replace asso_editor = "Bruno H. Strulovici" if asso_editor == "Bruno Strulovici"
	replace asso_editor = "Darrell J. Duffie" if asso_editor == "Darrell Duffie"
	replace asso_editor = "David S. Ahn" if asso_editor == "David Ahn"
	replace asso_editor = "Eduardo M. Azevedo" if asso_editor == "Eduardo Azevedo"
	replace asso_editor = "Gabriel D. Carroll" if asso_editor == "Gabriel Carroll"
	replace asso_editor = "Halbert L. White" if asso_editor == "Halbert White"
	replace asso_editor = "Jean M. Tirole" if asso_editor == "Jean Tirole"
	replace asso_editor = "Jonathan D. Levin" if asso_editor == "Jonathan Levin"
	replace asso_editor = "Laura L. Veldkamp" if asso_editor == "Laura Veldkamp"
	replace asso_editor = "Matthew J. Wiswall" if asso_editor == "Matthew Wiswall"
	replace asso_editor = "Neil G. Shephard" if asso_editor == "Neil Shephard"
	replace asso_editor = "Patrick M. Kline" if asso_editor == "Patrick Kline"
	replace asso_editor = "Rakesh V. Vohra" if asso_editor == "Rakesh Vohra"
	replace asso_editor = "Richard J. Stone" if asso_editor == "Richard Stone"
	replace asso_editor = "Robert J. Shimer" if asso_editor == "Robert Shimer"
	replace asso_editor = "Stephen E. Morris" if asso_editor == "Stephen Morris"
	replace asso_editor = "Susan C. Athey" if asso_editor == "Susan Athey"
	replace asso_editor = "Bengt R. Holmstrom" if asso_editor == "Bengt Holmstrom"
	replace asso_editor = "Moritz Meyer-Ter-Vehn" if asso_editor == "Moritz Meyer-ter-Vehn"
	** ==== Disambiguation ==== **
	replace asso_editor = "Charles A. Holt" if asso_editor == "Charles Holt"
	replace asso_editor = "David K. Levine" if asso_editor == "David Levine"
	replace asso_editor = "David J. Richardson" if asso_editor == "David Richardson"
	replace asso_editor = "Edward J. Hannan" if asso_editor == "Edward Hannan"
	replace asso_editor = "James D. Hamilton" if asso_editor == "James Hamilton"
	replace asso_editor = "John Y. Campbell" if asso_editor == "John Campbell"
	replace asso_editor = "Richard J. Smith" if asso_editor == "Richard Smith"
	replace asso_editor = "Robert M. Anderson" if asso_editor == "Robert Anderson"
	replace asso_editor = "Robert B. Wilson" if asso_editor == "Robert Wilson"
	replace asso_editor = "Stephen A. Ross" if asso_editor == "Stephen Ross"
	
	drop if year > 2019

	rename asso_editor author
	drop dupe
	compress
	save "${root}/econ/temp/asso_editor.dta", replace
end
program editor
	* editor
	insheet using "${root}/econ/input/raw/editor.csv", name clear

	drop coeditors
	split year, parse("-")
	destring year1 year2, replace

	by editor, sort: egen year_start = min(year1)
	by editor, sort: egen year_end = max(year2)
	drop year year1 year2
	duplicates drop editor, force

	gen term1 = year_start
	gen term2 = year_end
	rename (year_start year_end) (year1 year2)

	reshape long year, i(editor)
	drop _j
	order editor year

	egen id = group(editor)
	tsset id year
	tsfill, full

	local varlist editor term1 term2
	foreach var in `varlist' {
		bysort id: carryforward `var', gen(`var'_ex)
		drop `var'
		rename `var'_ex `var'
	}

	drop if term1 == .
	drop if year > term2
	order editor year
	sort term1 year
	drop term1 term2 id

	replace editor = "Angus S. Deaton" if editor == "Angus Deaton"
	replace editor = "Hugo F. Sonnenschein" if editor == "Hugo Sonnenschein"
	replace editor = "Daron K. Acemoglu" if editor == "Daron Acemoglu"
	replace editor = "Stephen E. Morris" if editor == "Stephen Morris"

	rename editor author
	compress
	save "${root}/econ/temp/editor.dta", replace
end

program coeditor
	* co-editor
	insheet using "${root}/econ/input/raw/editor.csv", name clear

	drop editor
	drop if coeditors == ""

	replace coeditors = subinstr(coeditors, "ä", "a", .)
	replace coeditors = subinstr(coeditors, "é", "e", .)
	replace coeditors = subinstr(coeditors, "ü", "u", .)

	split coeditors, parse(";")
	rename coeditors list_coeditor
	format %40s list_coeditor

	reshape long coeditors, i(year)
	drop _j list_coeditor

	split year, parse("-")
	destring year1 year2, replace
	drop year
	order coeditors year1 year2
	sort coeditors year1
	drop if coeditors == ""

	replace coeditors = "Lars Peter Hansen2" if coeditors == "Lars Peter Hansen" & year1 > 1990
	replace coeditors = "Robert H. Strotz2" if coeditors == "Robert H. Strotz" & year1 > 1960
	replace coeditors = "Thirukodikaval N. Srinivasan" if coeditors == "T. N. Srinivasan"
	replace coeditors = "Carl Von Weizsacker" if coeditors == "C. C. von Weizsacker"

	by coeditors, sort: egen year_start = min(year1)
	by coeditors, sort: egen year_end = max(year2)
	drop year1 year2
	duplicates drop coeditors, force

	gen term1 = year_start
	gen term2 = year_end
	rename (year_start year_end) (year1 year2)

	reshape long year, i(coeditors)
	drop _j
	order coeditors year

	egen id = group(coeditors)
	tsset id year
	tsfill, full

	local varlist coeditors term1 term2
	foreach var in `varlist' {
		bysort id: carryforward `var', gen(`var'_ex)
		drop `var'
		rename `var'_ex `var'
	}

	drop if term1 == .
	drop if year > term2
	order coeditors year
	sort term1 year
	drop term1 term2 id

	replace coeditors = subinstr(coeditors, "2", "", .)

	replace coeditors = "Angus S. Deaton" if coeditors == "Angus Deaton"
	replace coeditors = "Hugo F. Sonnenschein" if coeditors == "Hugo Sonnenschein"
	replace coeditors = "David E. Card" if coeditors == "David Card"
	replace coeditors = "Andrew W. Postlewaite" if coeditors == "Andrew Postlewaite"
	replace coeditors = "Christopher A. Sims" if coeditors == "Christopher Sims"
	replace coeditors = "David M. Kreps" if coeditors == "David Kreps"
	replace coeditors = "Douglas M. Gale" if coeditors == "Douglas Gale"
	replace coeditors = "Edmond Malinvaud" if coeditors == "Edmond C. Malinvaud"
	replace coeditors = "Harald F. Uhlig" if coeditors == "Harald Uhlig"
	replace coeditors = "Jacques H. Dreze" if coeditors == "Jacques Dreze"
	replace coeditors = "James A. Mirrlees" if coeditors == "James Mirrlees"
	replace coeditors = "Joel L. Horowitz" if coeditors == "Joel Horowitz"
	replace coeditors = "Kenneth F. Wallis" if coeditors == "Kenneth Wallis"
	replace coeditors = "Martin F. Hellwig" if coeditors == "Martin Hellwig"
	replace coeditors = "Menahem E. Yaari" if coeditors == "Menahem Yaari"
	replace coeditors = "Nancy L. Stokey" if coeditors == "Nancy Stokey"
	replace coeditors = "Peter M. Robinson" if coeditors == "Peter Robinson"
	replace coeditors = "Richard W. Blundell" if coeditors == "Richard Blundell"
	replace coeditors = "Robert H. Porter" if coeditors == "Robert Porter"
	replace coeditors = "Steven T. Berry" if coeditors == "Steven Berry"
	replace coeditors = "Carl Christian Von Weizsacker" if coeditors == "Carl Von Weizsacker"
	replace coeditors = "Daron K. Acemoglu" if coeditors == "Daron Acemoglu"
	replace coeditors = "Roger A. Guesnerie" if coeditors == "Roger Guesnerie"
	replace coeditors = "Gary E. Chamberlain" if coeditors == "Gary Chamberlain"

	duplicates drop
	rename coeditors author
	compress
	save "${root}/econ/temp/coeditor.dta", replace
end

main
