* parse and compile all fellow names to be included in the name match algorithm

clear all
set more off

global root "PATH/TO/REPLICATION/"
cd "${root}"
global econ_paper "econ_Paper_Level_clean.dta"

program main

    local field = "econ"
	combine_ECM2020, field(econ)
	AEA, field(econ)
	NBER, field(econ)
	sloan, field(econ)
	EMA_lecture, field(econ)
	AEA_pres
	AEA_vp
	editor
	asso_editor
	nomination
	
end


program clean_special
	replace author = subinstr(author, "’", "'", .)
	
	replace author = subinstr(author, "Á", "A", .)
	replace author = subinstr(author, "Å", "A", .)
	replace author = subinstr(author, "Ä°", "A", .)
	replace author = subinstr(author, "Ä", "A", .)
	replace author = subinstr(author, "Ã", "A", .)
	replace author = subinstr(author, "Ā", "A", .)
	replace author = subinstr(author, "Ã", "A", .)
	replace author = subinstr(author, "Ã³", "A", .)
	replace author = subinstr(author, "å", "a", .)
	replace author = subinstr(author, "á", "a", .)
	replace author = subinstr(author, "à", "a", .)
	replace author = subinstr(author, "ä", "a", .)
	replace author = subinstr(author, "æ", "ae", .)
	replace author = subinstr(author, "ã", "a", .)
	replace author = subinstr(author, "â", "a", .)
	replace author = subinstr(author, "a¹", "a", .)
	replace author = subinstr(author, "a¶", "o", .)
	replace author = subinstr(author, "a¤", "a", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00a4"), "a") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00a4"), "a") 
	
	replace author = subinstr(author, "ß", "b", .)
	
	replace author = subinstr(author, "č", "c", .)
	replace author = subinstr(author, "ć", "c", .)
	replace author = subinstr(author, "c̆", "c", .)
	replace author = subinstr(author, "Ç", "C", .)
	replace author = subinstr(author, "ç", "c", .)
	replace author = subinstr(author, "¢", "c", .)
	replace author = subinstr(author, "Č", "C", .)
	replace author = subinstr(author, "©", "c", .)
	replace author = subinstr(author, "§", "c", .)
	
	replace author = subinstr(author, "É", "E", .)
	replace author = subinstr(author, "Ë", "E", .)
	replace author = subinstr(author, "é", "e", .)
	replace author = subinstr(author, "è", "e", .)
	replace author = subinstr(author, "ě", "e", .)
	replace author = subinstr(author, "ë", "e", .)
	replace author = subinstr(author, "ȩ", "e", .)
	
	replace author = subinstr(author, "ǧ", "g", .)
	replace author = subinstr(author, "ğ", "g", .)
	replace author = subinstr(author, "ǧ̃", "g", .)
	replace author = subinstr(author, "g̃", "g", .)
	replace author = subinstr(author, "gˇ", "g", .)
	replace author = subinstr(author, "Ğ", "g", .)
	replace author = subinstr(author, "ḡ", "g", .)
	
	replace author = subinstr(author, "İ", "I", .)
	replace author = subinstr(author, "Î", "I", .)
	replace author = subinstr(author, "Í", "I", .)
	replace author = subinstr(author, "Ì", "I", .)
	replace author = subinstr(author, "Ï", "I", .)
	replace author = subinstr(author, "i̇", "i", .)
	replace author = subinstr(author, "ı̈", "i", .)
	replace author = subinstr(author, "ï", "i", .)
	replace author = subinstr(author, "ı¨", "i", .)
	replace author = subinstr(author, "ı́", "i", .)
	replace author = subinstr(author, "í", "i", .)
	replace author = subinstr(author, "ĭ", "i", .)
	replace author = subinstr(author, "iˇ", "i", .)
	replace author = subinstr(author, "iˆ", "i", .)
	replace author = subinstr(author, "ı", "i", .)
	replace author = subinstr(author, "î", "i", .)
	replace author = subinstr(author, "¡", "i", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00ad"), "i") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00ad"), "i") 
	
	replace author = subinstr(author, "Ł", "L", .)
	replace author = subinstr(author, "Ľ", "L", .)
	replace author = subinstr(author, "ł", "l", .)
	
	replace author = subinstr(author, "Ñ", "N", .)
	replace author = subinstr(author, "ń", "n", .)
	replace author = subinstr(author, "ñ", "n", .)
	
	replace author = subinstr(author, "Ø", "O", .)
	replace author = subinstr(author, "Ó", "O", .)
	replace author = subinstr(author, "Ö", "O", .)
	replace author = subinstr(author, "Ò", "O", .)
	replace author = subinstr(author, "Ō", "O", .)
	replace author = subinstr(author, "ö", "o", .)
	replace author = subinstr(author, "Ó", "O", .)
	replace author = subinstr(author, "ó", "o", .)
	replace author = subinstr(author, "ò", "o", .)
	replace author = subinstr(author, "ø", "o", .)
	replace author = subinstr(author, "ô", "o", .)
	replace author = subinstr(author, "ő", "o", .)
	replace author = subinstr(author, "œ", "oe", .)
	replace author = subinstr(author, "Œ", "oe", .)
	replace author = ustrregexra(author, ustrunescape("\u0041\u00b6"), "o") 
	replace author = ustrregexra(author, ustrunescape("\u0061\u00b6"), "o") 
	
	replace author = subinstr(author, "ř", "r", .)
	
	replace author = subinstr(author, "š", "s", .)
	replace author = subinstr(author, "ş", "s", .)
	replace author = subinstr(author, "Š", "S", .)
	replace author = subinstr(author, "Ş", "S", .)
	replace author = subinstr(author, "Ś", "S", .)
	
	replace author = subinstr(author, "ü", "u", .)
	replace author = subinstr(author, "ú", "u", .)
	replace author = subinstr(author, "ü", "u", .)
	replace author = subinstr(author, "Ü", "U", .)
	replace author = subinstr(author, "Ú", "U", .)
	
	replace author = subinstr(author, "ý", "y", .)
	
	replace author = subinstr(author, "Ž", "Z", .)
	replace author = subinstr(author, "ž", "z", .)
	
	
	replace author = subinstr(author, " ", " ", .)
	replace author = subinstr(author, "–", "-", .)
	replace author = subinstr(author, "‐", "-", .)
	replace author = subinstr(author, "¨", "-", .)
end

program name_parse
	* parse the names
	split author, parse(" ")
	local nsplit = r(nvars)
	gen last_name = ""
	forval y = 1/`nsplit' {
		replace last_name = author`y' if !missing(author`y')
	}

	rename author1 first_name

	gen middle_name = ""
	forval y = 2/`nsplit' {
		replace middle_name = middle_name + " " + author`y' if !missing(author`y') & author`y' != last_name
	}
	replace middle_name = strtrim(middle_name)

	* change x. xxx xxx into xxx x. xxx
	gen fi = first_name
	replace first_name = middle_name if ustrregexm(first_name, "^[A-Z]\.")==1 & ustrregexm(middle_name, "[A-Za-z]\.") == 0 & lower(middle_name) != "de" & lower(middle_name) != "van" & lower(middle_name) != "von" & lower(middle_name) != "la" & middle_name != ""

	* change middle names to first initials 
	replace middle_name = substr(middle_name, 1, 1) + "." if strlen(middle_name) > 2 & strpos(middle_name, ".") == 0

	replace middle_name = fi if author2 == first_name

	gen author_full = first_name + " " + middle_name + " " + last_name if middle_name != ""
	drop fi author2-author`nsplit'
	
	order author first_name middle_name last_name

	* generate variables to match
	gen author_nomi = first_name + " " + last_name
	replace author_full = author_nomi if author_full == ""

	gen author_fellow = author_full

	replace author_fellow = proper(author_fellow)
	replace author_full = proper(author_full)

	drop author first_name middle_name
end

program combine_ECM2020
	syntax, field(str)
	* append the 2020 elected fellows 
	local field = "econ"
	import delimited "${root}/`field'/input/raw/fellows_2020.csv", stringcols(1) encoding(UTF-8)clear
	clean_special
	replace author = proper(author)

	name_parse
	
	tostring female, replace 
	append using "${root}/`field'/input/raw/fellows.dta"
	replace author_full = author if author_full == ""
	drop author no
	
	rename author_full author
	keep author year
	rename year year
	collapse (mean) year, by(author)
	save "${root}/`field'/temp/fellows_names.dta", replace
end

program AAAS
	syntax, field(str)
	if "`field'" == "econ" {
		local subfield_curr = "Economics"
	}
	if "`field'" == "psych" {
		local subfield_curr = "Psychological Sciences"
	}
	use "${root}/AAAS/AAAS.dta" if subfield == "`subfield_curr'", clear 

	drop institution occupation field subfield status Male Ambiguous 

	rename year year_appointed_AAAS
	rename (Female fellow) (female_AAAS author)

	clean_special
	name_parse
	rename author_full author
	keep author year
	rename year year
	collapse (mean) year, by(author)
	
	compress
	save "${root}/`field'/temp/AAAS_names.dta", replace
end


program NAS
	syntax, field(str)
	* Prepare 2nd field indicator
	* append the fellows whose secondary field is economics 
	use  "${root}/`field'/input/raw/NAS_econ.dta", clear /* initially left out of the fellows dataset */
	keep if secondary == "Economic Sciences" | fellow == "Theodore Schultz" | fellow == "James Poterba" | fellow == "George Stigler" 

	drop institution primary secondary 
	rename (fellow female year) (author female_NAS year_appointed_NAS) 

	name_parse

	append using "${root}/`field'/output/NAS_fellows_clean.dta"
	keep author year
	rename year year
	collapse (mean) year, by(author)
	compress
	save "${root}/`field'/temp/NAS_names.dta", replace
end

program AEA
	syntax, field(str)
	*** clean the AEA distinguished fellows
	local field = "econ"
	import delimited "${root}/`field'/input/raw/AEA_Distinguished_Fellows_Elected.csv", encoding(UTF-8)clear

	drop no v7 v8 v9 v10 original

	rename year_elected year_appointed_AEA
	rename female female_AEA

	replace name = strtrim(name)
	replace lastname = strtrim(lastname)

	gen author = name + " " + lastname

	clean_special
	
	replace author = proper(author)

	name_parse
	
	rename author_full author
	keep author year
	rename year year
	collapse (mean) year, by(author)
	compress
	save "${root}/`field'/temp/AEA_names", replace
end

*** clean the NBER fellows
program NBER
	syntax, field(str)
	clear
	* the following files are .dta conversions of csvs found in input/raw/NBER/csv
	foreach file in ag ap cf ch dae dev ed eee efg hc he ifm io iti le ls me pe pol pr {
		append using  "${root}/`field'/input/raw/NBER/NBER_clean_`file'.dta"
	}

	gen tag = author_full + date_appointed1

	destring date_appointed1, replace
	sort author_full date_appointed1

	duplicates drop tag, force
	drop tag

	replace author_full = trim(author_full)

	gen id = _n

	drop if id == 305
	drop if id == 964
	drop if id == 1126
	drop if id == 1150

	rename date_appointed1 year_appointed_NBER

	rename author_full author
	keep author year
	rename year year
	collapse (mean) year, by(author)
	compress
	save "${root}/`field'/temp/NBER_names.dta", replace
end


program sloan
	syntax, field(str)
	import excel "${root}/`field'/input/raw/Sloan_Fellows_Elected.xlsx", sheet("Sloan_Fellows") firstrow clear


	drop no field affiliation

	rename year_appointed year_appointed_Sloan
	rename female female_Sloan

	replace name = strtrim(name)
	replace lastname = strtrim(lastname)

	gen author = name + " " + lastname

	clean_special

	replace author = proper(author)

	name_parse
	rename author_full author

	keep author year
	rename year year
	collapse (mean) year, by(author)
	compress
	save "${root}/`field'/temp/Sloan_names.dta", replace
end

program EMA_lecture
	syntax, field(str)
	* Fisher-Schultz Lecture
	local field = "econ"
	import excel  "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Fisher-Schultz Lecture") firstrow clear

	drop affiliation title original
	rename (author_1 author_2) (author1 author2)

	* collapse to author-year level
	reshape long author, i(year)
	drop if missing(author)
	drop _j

	* clean up some names
	
	save "${root}/`field'/input/raw/ECMA_lectures/FS_lecture.dta", replace

	* Jacob-Marschak Lecture
	import excel "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Jacob Marschak Lecture") firstrow clear

	drop title location city_country original
	drop if author == ""

	save "${root}/`field'/input/raw/ECMA_lectures/JM_lecture.dta", replace

	* Walras-Bowley Lecture
	import excel "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Walras-Bowley Lecture") firstrow clear

	drop title affiliation original
	rename name author
	replace author = strtrim(author)

	save "${root}/`field'/input/raw/ECMA_lectures/WB_lecture.dta", replace

	* Frisch Memorial Lecture
	import excel "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Frisch Memorial Lecture") firstrow clear

	drop affiliation original
	rename name author

	save "${root}/`field'/input/raw/ECMA_lectures/FM_lecture.dta", replace

	* Cowles Lecture
	import excel "${root}/`field'/input/raw/ECMA_lectures/ECMA_Lectures.xlsx", sheet("Cowles Lecture") firstrow clear

	drop affiliation original
	rename name author
	replace author = strtrim(author)

	save "${root}/`field'/input/raw/ECMA_lectures/C_lecture.dta", replace

	*** Merge the lectures together
	local field = "econ"
	use "${root}/`field'/input/raw/ECMA_lectures/FS_lecture.dta", clear

	append using "${root}/`field'/input/raw/ECMA_lectures/JM_lecture.dta"
	append using "${root}/`field'/input/raw/ECMA_lectures/WB_lecture.dta"
	append using "${root}/`field'/input/raw/ECMA_lectures/FM_lecture.dta"
	append using "${root}/`field'/input/raw/ECMA_lectures/C_lecture.dta"

	order author year
	sort author year

	replace author = proper(author)

	* take the earliest lecture
	bys author (year): keep if _n == 1

	* parse the names
	replace author = subinstr(author, " ", " ", .)
	
	name_parse
	
	rename year year_appointed_EMALEC
	rename author_full author
	
	keep author year
	rename year year
	collapse (mean) year, by(author)
	compress
	save "${root}/`field'/temp/EMALEC_names.dta", replace
end


program AEA_pres
	*** clean the AEA President 

	import delimited "${root}/econ/input/raw/aea_president.csv",encoding(UTF-8)clear

	* split string 
	replace v1 = strtrim(v1)
	split v1, p(",")
	rename v11 author 
	rename v12 institute 
	rename v13 year_appointed 
	replace year_appointed = "1981" if author == "WILLIAM J. BAUMOL"
	replace year_appointed = "2002" if author == "ROBERT E. LUCAS"
	replace year_appointed = "2001" if author == "SHERWIN ROSEN"
	replace institute = "Chicago" if author == "ROBERT E. LUCAS"
	replace author = "ROBERT E. LUCAS JR." if author == "ROBERT E. LUCAS"
	replace author = "FRANCIS A. WALKER" if strpos(author, "FRANCIS A. WALKER")
	replace year_appointed = "1886-92" if author == "FRANCIS A. WALKER"
	replace year_appointed = "1978" if author == "JACOB MARSCHAK"

	* clean term date 
	split year_appointed, p("-")
	rename year_appointed1 term_date1 
	rename year_appointed2 term_date2
	replace term_date2 = "." if term_date2 == ""
	replace term_date2 = substr(term_date1, 1, 2) + term_date2 if term_date2 != "."
	drop institute v14 v1 year_appointed 

	clean_special

	* clean author name 
	split author, p(" ")
	gen lastname = "."

	replace lastname = author2 if missing(author3) & missing(author4)
	replace lastname = author3 if missing(author4) & lastname == "."
	replace lastname = author4 if lastname == "."

	rename author1 firstname
	rename author2 middle_name1
	rename author3 middle_name2

	replace middle_name1 = "" if middle_name1 == lastname
	replace middle_name2 = "" if middle_name2 == lastname

	drop author4

	replace firstname = substr(firstname, 1, 1) + lower(substr(firstname, 2, length(firstname)-1))
	replace middle_name1 = substr(middle_name1, 1, 1) + lower(substr(middle_name1, 2, length(middle_name1)-1))
	replace middle_name2 = substr(middle_name2, 1, 1) + lower(substr(middle_name2, 2, length(middle_name2)-1))
	replace lastname = substr(lastname, 1, 1) + lower(substr(lastname, 2, length(lastname)-1))

	gen new_author = ""
	gen author_nomi = ""
	replace new_author = firstname + " " + lastname if middle_name1 == "" & middle_name2 == ""
	replace new_author = firstname + " " + middle_name1 + " " + lastname if middle_name1 != "" & middle_name2 == ""
	replace new_author = firstname + " " + middle_name1 + " " + middle_name2 + " " + lastname if new_author == ""
	replace author_nomi = firstname + " " + lastname 
	replace author = new_author
	drop new_author firstname lastname middle_name1 middle_name2 
	order author author_nomi term_date1 term_date2

	gen year1 = term_date1
	gen year2 = term_date2
	destring term_date1 term_date2, replace

	reshape long year, i(author)
	drop _j
	order author year
	sort year author 
	destring year, replace
	drop if year == .

	egen id = group(author)
	tsset id year
	tsfill, full
	list, clean noobs

	local varlist author author_nomi term_date1 term_date2 
	foreach var in `varlist' {
		bysort id: carryforward `var', gen(`var'_ex)
		drop `var'
		rename `var'_ex `var'
	}

	drop if term_date1 == .
	drop if year > term_date2 & term_date2 != .
	drop if year > term_date1 & term_date2 == .
	order author author_nomi year 
	sort year
	drop term_date1 term_date2 id
	
	
	keep author year
	rename year year
	collapse (mean) year, by(author)
	
	compress
	save "${root}/econ/temp/aea_president_names.dta", replace
end

program AEA_vp
	*** clean the AEA Vice President 
	import delimited "${root}/econ/input/raw/aea_vp.csv",encoding(UTF-8)clear
	* split string 
	replace v1 = strtrim(v1)
	split v1, p(",")
	rename v11 author 
	rename v12 year  
	replace year = "1949" if strpos(author, "THEODORE W. SCHULTZ")
	replace year = "1987" if author == "ROBERT E. LUCAS"
	replace author = "THEODORE W. SCHULTZ" if strpos(author, "THEODORE W. SCHULTZ")
	destring year, replace 

	clean_special

	* clean author name 
	split author, p(" ")
	gen lastname = "."

	replace lastname = author2 if missing(author3)
	replace lastname = author3 if lastname == "."
	rename author1 firstname
	rename author2 middle_name1
	rename author3 middle_name2

	replace middle_name1 = "" if middle_name1 == lastname
	replace middle_name2 = "" if middle_name2 == lastname

	drop middle_name2

	replace firstname = substr(firstname, 1, 1) + lower(substr(firstname, 2, length(firstname)-1))
	replace middle_name1 = substr(middle_name1, 1, 1) + lower(substr(middle_name1, 2, length(middle_name1)-1))
	replace lastname = substr(lastname, 1, 1) + lower(substr(lastname, 2, length(lastname)-1))

	gen new_author = ""
	gen author_nomi = ""
	replace new_author = firstname + " " + lastname if middle_name1 == ""
	replace new_author = firstname + " " + middle_name1 + " " + lastname if middle_name1 != "" & new_author == ""
	replace author_nomi = firstname + " " + lastname 
	replace author = new_author
	drop new_autho firstname lastname middle_name1 v1 
	sort year 

	order author author_nomi year 
	
	keep author year
	rename year year
	collapse (mean) year, by(author)
	compress
	save "${root}/econ/temp/aea_vp_names.dta", replace
end


program asso_editor 
	* associate editor
	insheet using "${root}/econ/input/raw/asso_editor.csv", name clear


	replace firstname = subinstr(firstname, "-", "-", .)
	replace lastname = subinstr(lastname, "ä", "a", .)
	replace lastname = subinstr(lastname, "ï", "i", .)
	replace lastname = subinstr(lastname, "ö", "o", .)
	replace firstname = subinstr(firstname, "á", "a", .)

	replace firstname = "Donald W. K." if firstname == "Donald W.K."
	replace firstname = "Douglas B." if firstname == "B. Douglas"
	replace firstname = "V. V." if firstname == "V.V."
	replace firstname = "G. S." if firstname == "G.S."
	replace firstname = "Peter J." if firstname == "J. Peter"
	replace firstname = "Hashem M." if firstname == "M. Hashem"
	replace firstname = "Richard J." if firstname == "J. Richard"
	replace firstname = "Dudley T." if firstname == "T. Dudley"
	replace firstname = "John D." if firstname == "D. John"

	gen asso_editor = firstname + " " + lastname
	drop lastname firstname
	order asso_editor

	split termdate, parse("-")
	gen year1 = termdate1
	gen year2 = termdate2
	destring termdate1 termdate2, replace

	gen dupe = (asso_editor[_n]==asso_editor[_n-1])
	preserve
		keep if dupe == 1
		reshape long year, i(asso_editor)
		drop termdate _j
		order asso_editor year
		destring year, replace
		drop if year == .
		
		egen id = group(asso_editor)
		tsset id year
		tsfill, full

		local varlist asso_editor termdate1 termdate2
		foreach var in `varlist' {
			bysort id: carryforward `var', gen(`var'_ex)
			drop `var'
			rename `var'_ex `var'
		}

		drop if termdate1 == .
		drop if year > termdate2
		order asso_editor year
		drop termdate1 termdate2 id
		
		tempfile multiterm
		save "`multiterm'"
	restore

	keep if dupe == 0
	reshape long year, i(asso_editor)
	drop termdate _j
	order asso_editor year
	destring year, replace
	drop if year == .

	egen id = group(asso_editor)
	tsset id year
	tsfill, full

	local varlist asso_editor termdate1 termdate2
	foreach var in `varlist' {
		bysort id: carryforward `var', gen(`var'_ex)
		drop `var'
		rename `var'_ex `var'
	}

	drop if termdate1 == .
	drop if year > termdate2
	order asso_editor year
	drop termdate1 termdate2 id
	append using "`multiterm'"

	sort asso_editor year

	replace asso_editor = subinstr(asso_editor, "ö", "o", .)


	rename asso_editor author
	
	keep author year
	rename year year
	collapse (mean) year, by(author)
	compress
	save "${root}/econ/temp/asso_editor_names.dta", replace
end
program editor
	* editor
	insheet using "${root}/econ/input/raw/editor.csv", name clear

	drop coeditors
	split year, parse("-")
	destring year1 year2, replace

	by editor, sort: egen year_start = min(year1)
	by editor, sort: egen year_end = max(year2)
	drop year year1 year2
	duplicates drop editor, force

	gen term1 = year_start
	gen term2 = year_end
	rename (year_start year_end) (year1 year2)

	reshape long year, i(editor)
	drop _j
	order editor year

	egen id = group(editor)
	tsset id year
	tsfill, full

	local varlist editor term1 term2
	foreach var in `varlist' {
		bysort id: carryforward `var', gen(`var'_ex)
		drop `var'
		rename `var'_ex `var'
	}

	drop if term1 == .
	drop if year > term2
	order editor year
	sort term1 year
	drop term1 term2 id

	rename editor author
	
	keep author year
	rename year year
	collapse (mean) year, by(author)
	save "${root}/econ/temp/editor_names.dta", replace
end

program coeditor
	* co-editor
	insheet using "${root}/econ/input/raw/editor.csv", name clear

	drop editor
	drop if coeditors == ""

	replace coeditors = subinstr(coeditors, "ä", "a", .)
	replace coeditors = subinstr(coeditors, "é", "e", .)
	replace coeditors = subinstr(coeditors, "ü", "u", .)

	split coeditors, parse(";")
	rename coeditors list_coeditor
	format %40s list_coeditor

	reshape long coeditors, i(year)
	drop _j list_coeditor

	split year, parse("-")
	destring year1 year2, replace
	drop year
	order coeditors year1 year2
	sort coeditors year1
	drop if coeditors == ""

	by coeditors, sort: egen year_start = min(year1)
	by coeditors, sort: egen year_end = max(year2)
	drop year1 year2
	duplicates drop coeditors, force

	gen term1 = year_start
	gen term2 = year_end
	rename (year_start year_end) (year1 year2)

	reshape long year, i(coeditors)
	drop _j
	order coeditors year

	egen id = group(coeditors)
	tsset id year
	tsfill, full

	local varlist coeditors term1 term2
	foreach var in `varlist' {
		bysort id: carryforward `var', gen(`var'_ex)
		drop `var'
		rename `var'_ex `var'
	}

	drop if term1 == .
	drop if year > term2
	order coeditors year
	sort term1 year
	drop term1 term2 id

	replace coeditors = subinstr(coeditors, "2", "", .)

	rename coeditors author
	
	keep author year
	rename year year
	collapse (mean) year, by(author)
	save "${root}/econ/temp/coeditor_names.dta", replace
end


main
