clear all
set more off

global root "PATH/TO/REPLICATION/"
cd "${root}"
global econ_paper "econ_Paper_Level_clean.dta"

global econ_cite ecta qje aer jpe restud

program main

	local field = "econ"
	use "${root}/`field'/output/fellows_matched_rectangular.dta", clear
	drop if author == ""

	* merge the ECTA citations
	local loop = "`field'_cite"
	foreach cite in $`loop' {
		if "`cite'" == "restud" {
			local var = "REStud"
		}
		else {
			local var = upper("`cite'")
		}
		
		merge 1:1 author year using "${root}/`field'/temp/author_year_`cite'_citation.dta", keep(1 3) nogen
		replace `var'_cite = 0 if `var'_cite == . 
		replace multi_`var'_cite = 0 if multi_`var'_cite == . 
		replace single_`var'_cite = 0 if single_`var'_cite == . 

		replace `var'_cite = 0 if `var'_cumulative == 0 & `var'_cite > 0  
		replace multi_`var'_cite = 0 if `var'_cumulative == 0 & multi_`var'_cite > 0  
		replace single_`var'_cite = 0 if `var'_cumulative == 0 & single_`var'_cite > 0  

		bysort author (year): gen `var'_cite_cumulative = sum(`var'_cite)
		bysort author (year): gen single_`var'_cite_cumulative = sum(single_`var'_cite)
		bysort author (year): gen multi_`var'_cite_cumulative = sum(multi_`var'_cite)
	}

	compress
	save "${root}/`field'/output/fellows_matched_rectangular_citation.dta", replace
end

main
