clear all

import delimited using "temp/matches_first_run.csv", clear varn(1)
save "temp/first_matches.dta", replace

**keep exact matches
keep if match == authors
tempfile temp
save "`temp'"

import delimited "names.csv", clear varn(1)
merge m:1 authors using "`temp'"

rename _m merge_vs_firstRun
save "temp/intermediate_matches_long", replace


drop if merge == 3
drop merge
** middle names
replace authors = ustrregexra(authors, " [A-Z]\. "," ")
replace authors = ustrregexra(authors, " [A-Z]\.\, "," ")

** leading initial
replace authors = ustrregexra(authors, "^[A-Z]\. "," ")
replace authors = ustrregexra(authors, "^[A-Z]\.\, "," ")


keep authors

split authors, p(" ")

gen Name = authors1 + " " + authors2
rename (authors1 authors2) (FirstName LastName)
keep FirstName LastName Name
order FirstName LastName Name

save "temp/UniqueNames.dta", replace
