
##### Houskeeping #####
rm(list=ls())

options(java.parameters = "-Xmx2048m")
library('haven')
library('rstudioapi')
library('dplyr')
library('stringdist')
library('stringr')
library('readr')

localeToCharset(locale = Sys.getlocale("LC_CTYPE"))

# Set path
setwd('')


print(getwd())


# Timer
startTime<-proc.time()

##### Load data #####

# Load leftover names
EconLit_UniqueNames = read_dta('temp/UniqueNames.dta')

# Create econlit flag
EconLitName <- EconLit_UniqueNames
EconLitName$EconLit <- 1
EconLitName <- select(EconLitName, Name, EconLit)
EconLitName <- unique(EconLitName)



#####  Create name list #####
UniqueNames = rbind(EconLit_UniqueNames)

UniqueFirstNames = unique(UniqueNames$FirstName)
UniqueFirstNames = UniqueFirstNames[order(UniqueFirstNames)]

UniqueFullNames = unique(UniqueNames$Name)
UniqueFullNames = UniqueFullNames[order(UniqueFullNames)]

save(UniqueNames, UniqueFirstNames, UniqueFullNames, EconLitName, 
     file='temp/UniqueNames.RData')

proc.time() - startTime