clear all

use "temp/intermediate_matches_long.dta", clear

rename authors Name

merge m:1 Name using "temp/Gender_Names_Full.dta", keep(1 3) 
destring gender_*, replace force
replace gender_m = Gender_M if _m == 3
replace gender_f = Gender_F if _m == 3
replace gender_a = Gender_A if _m == 3

gen CommonCH = (CommonCH_Given == 1 & CommonCH_Surname == 1)

replace gender_m = 0 if CommonCH == 1
replace gender_f = 0 if CommonCH == 1
replace gender_a = 1 if CommonCH == 1

 
replace gender_m = 0 if missing(gender_a)
replace gender_f = 0 if missing(gender_a)
replace gender_a = 1 if missing(gender_a)

keep Name gender_m gender_f gender_a
order Name gender_m gender_f gender_a
format %20s Name
rename (gender_m gender_f gender_a) (Male Female Ambiguous)
save "output/gender_name.dta", replace
