* figure1

clear
if !missing("$dropbox_dir") {
	local dropbox_dir = "$dropbox_dir"
}
else {
	local dropbox_dir = "C:/Users/Chris/Dropbox"
}
cd "`dropbox_dir'/ECM_Fellow_Study/Replication"
use "`dropbox_dir'\ECM_Fellow_Study\Paper2\econ\output\regression_dataset_public.dta"

cap log close 
log using "figures/f1.log", replace

* keep the unmatched fellows
foreach x in EMA NAS AAAS AEAF Sloan {
	replace new_fellow_`x' = 1 if year == . & !missing(year_appointed_`x')
	replace new_fellow_`x' = 0 if year == . & missing(year_appointed_`x')
	replace year = year_appointed_`x' if year == . & !missing(year_appointed_`x')
}

* keep the fellows who are elected 18+ years after first publications
* replace year in data to be the year appointed to the fellowship
gen keep_fellow_EMA = (ever_fellow_EMA == 1 & fellow_EMA == 0 & years_lastpub == 18)
replace new_fellow_EMA = 1 if keep_fellow_EMA == 1
replace year = year_appointed_EMA if keep_fellow_EMA == 1 
local varlist AAAS NAS AEAF Sloan
foreach v in `varlist'{
	gen keep_fellow_`v' = 1 if fellow_`v' == 0 & ever_fellow_`v' == 1 & years_lastpub == 18
	replace year = year_appointed_`v' if keep_fellow_`v' == 1
	replace new_fellow_`v' = 1 if keep_fellow_`v' == 1
}

drop keep_fellow_*

drop if missing(new_fellow_EMA) & missing(new_fellow_AAAS) & missing(new_fellow_NAS) & missing(new_fellow_AEAF)

replace new_fellow_EMA = 0 if year_appointed_EMA == .
replace new_fellow_NAS = 0 if year_appointed_NAS == .
replace new_fellow_AAAS = 0 if year_appointed_AAAS == .
replace new_fellow_AEA = 0 if year_appointed_AEAF == .
replace new_fellow_Sloan = 0 if year_appointed_Sloan == .

replace new_fellow_NAS = 0 if primary_NAS_econ == 0
replace new_fellow_AAAS = 0 if AAAS_flags == 3

gen new_ema=new_fellow_EMA
gen new_nas=new_fellow_NAS
gen new_slo=new_fellow_Sloan
gen new_aea=new_fellow_AEAF
gen new_aaas=new_fellow_AAAS


gen f_new_ema=Female*new_ema
gen f_new_nas=Female*new_nas
gen f_new_slo=Female*new_slo
gen f_new_aea=Female*new_aea
gen f_new_aaas=Female*new_aaas


sum new_* f_new_*

drop if year<1933


collapse (sum) new_ema new_nas new_slo new_aea new_aaas f_new_ema f_new_nas f_new_slo f_new_aea f_new_aaas, by(year)


save "figures/figure1.dta", replace
export excel "figures/figure1.xls", replace first(var)
sum

log close
