* table 5

clear all
set more off
set trace off
if !missing("$dropbox_dir") {
	local dropbox_dir = "$dropbox_dir"
}
else {
	local dropbox_dir "C:/Users/Chris/Dropbox"
}
cd "`dropbox_dir'/ECM_Fellow_Study/Replication"
use "`dropbox_dir'/ECM_Fellow_Study/tables/figures/figure2/figure2.dta"

cap log close 
log using "tables/table5.log", replace

gen interval=0
replace interval=1 if year>=1995 & year<=2005 & year != 2003
replace interval=2 if year>=2006 & year<=2011
replace interval=3 if year>=2012 & year<=2019

drop if interval==0

tab year interval

*F means fellow f means female
gen n_act=asnyf
gen fs_act=fshare_asnyf

gen n_new=new_ema
gen fs_new=fshare_new_ema

gen n_nom=nominee
gen fs_nom=fshare_nominee

gen n_nom_c=nominee_byCommitty
gen n_nom_F=nominee_byFellow   

gen cs_nom=n_nom_c/n_nom

gen fs_nom_c=fshare_nominee_byCommitty
gen fs_nom_F=fshare_nominee_byFellow

gen check=fs_nom-cs_nom*fs_nom_c-(1-cs_nom)*fs_nom_F
sum check


gen nf_nom_c = round( n_nom_c * fs_nom_c , 1) 
gen nf_nom_F = round( n_nom_F * fs_nom_F , 1)
gen nf_nom = round( nf_nom_c + nf_nom_F, 1)

replace nf_nom_c=0 if nf_nom_c ==.
replace nf_nom_F=0 if nf_nom_F ==.
replace nf_nom = 0 if nf_nom ==.

gen cs_f_nom=nf_nom_c/nf_nom

*this is the relative share of females nominated by committee
gen relcs_f=cs_f_nom/cs_nom

gen se_nom_c =share_elect_nominee_byCommitty
gen se_nom_F =share_elect_nominee_byFellow
gen se_nom   = se_nom_c*cs_nom + se_nom_F*(1-cs_nom)


gen se_fnom_c=share_elect_f_nominee_byCommitty
gen se_fnom_F=share_elect_f_nominee_byFellow
gen se_fnom =(  se_fnom_c* nf_nom_c + se_nom_F *nf_nom_F)/nf_nom


sum fs_new fs_nom fs_nom_c fs_nom_F cs_nom fs_nom_c cs_nom cs_f_nom relcs_f se_nom se_nom_c se_nom_F se_fnom se_fnom_c se_fnom_F


sort interval

gen check2=n_nom-n_nom_c-n_nom_F
sum check2

list year n_nom n_nom_c n_nom_F

list year n_nom nf_nom nf_nom_c nf_nom_F



by interval: sum fs_new [fweight=n_new]
by interval: sum fs_nom [fweight=n_nom]
by interval: sum fs_nom_c [fweight=n_nom_c]
by interval: sum fs_nom_F [fweight=n_nom_F]


by interval: sum cs_nom [fweight=n_nom]
by interval: sum cs_f_nom [fweight=nf_nom]
by interval: sum relcs_f [fweight=nf_nom]  


by interval: sum se_nom [fweight=n_nom]
by interval: sum se_nom_c [fweight=n_nom_c]
by interval: sum se_nom_F [fweight=n_nom_F]

by interval: sum se_fnom [fweight=nf_nom]
by interval: sum se_fnom_c [fweight=nf_nom_c]
by interval: sum se_fnom_F [fweight=nf_nom_F]


log off 
log close 
