# Nomination Text Analysis 

## Environment Setup

Docker might be preferable, but setting up nvidia-docker might be another can of worms. 
I'd recommend the following if not using docker.

On Ubuntu 20.04, install [Miniconda](https://docs.conda.io/en/latest/miniconda.html). 

Run the following in a terminal window when in the replication directory:
``` bash
conda env create -f environment.yml
conda activate nomination_replication
```

I think the environment will still install without a gpu, but speed of inference using 
spacy's transformer-based language model will suffer greatly. Code will also need to be slightly adjusted.


## Replication
__Prerequisite__: The dropbox directory must be filled in `merge_nomination.do`. 

The notebook server can be started with `jupyter notebook`. Visit the server link, and following the instructions in 
`text_analysis_replication.ipynb`. I tried my best to keep paths relative, but let me know if anything breaks!


