clear 

local dropbox_dir "<DROPBOX_DIR_NO_TRAILING_SLASH>"

use "`dropbox_dir'/ECM_Fellow_Study/source/compile_author/output/fellows_matched_rectangular_citation.dta"

keep if nominee == 1 & year <= 2019 & year >= 2006
keep author year author_nomi Female new_fellow_EMA ECTA_cumulative REStud_cumulative AER_cumulative QJE_cumulative JPE_cumulative ///
	ECTA_cite_cumulative REStud_cite_cumulative AER_cite_cumulative QJE_cite_cumulative JPE_cite_cumulative


* merge using full_name (privileged dataset, will need change dropbox path)
merge 1:1 author year using "`dropbox_dir'/ECM_Fellow_Study/DATA_Nominees/ResearchFilesXlsx/combinedSummary_0619full.dta"
preserve 
keep if _merge == 3
compress 
save "temp/nomination_fullmerge_rectangular.dta", replace
restore 

* partially matched, ignoring middle names
keep if _merge != 3

preserve
keep if _merge == 1
drop _merge 
compress 
save "temp/nomination_master_interim_rectangular.dta", replace
restore

preserve
keep if _merge == 2
drop _merge 
compress 
save "temp/nomination_using_interim_rectangular.dta", replace
restore


use "temp/nomination_master_interim_rectangular.dta", clear
merge m:1 author_nomi year using "temp/nomination_using_interim_rectangular.dta", update
keep if _merge == 5 
drop _merge 

append using "temp/nomination_fullmerge_rectangular.dta"
drop _merge 
order ECTA_cumulative REStud_cumulative AER_cumulative QJE_cumulative JPE_cumulative ///
	  ECTA_cite_cumulative REStud_cite_cumulative AER_cite_cumulative QJE_cite_cumulative JPE_cite_cumulative author_nomi, last 
	  
order author year Female new_fellow_EMA nomStatement
sort author year 

save "combinedSummary_full_merged_replication.dta", replace
