clear
eststo clear

import delimited using "word_indicators_for_stata.csv", bindquotes(loose) varnames(1) maxquotedrows(100) clear

qui gen asinhREScites=asinh(restud_cite_cumulative)
qui gen asinhEMAcites=asinh(ecta_cite_cumulative)
qui gen asinhAERcites=asinh(aer_cite_cumulative)
qui gen asinhQJEcites=asinh(qje_cite_cumulative)
qui gen asinhJPEcites=asinh(jpe_cite_cumulative)


local i=1


matrix female_stats = J(567, 4, .)
matrix new_fellow_stats = J(567, 4, .)

putexcel set word_regression_female_output.xls, replace

foreach x of varlist word_* {

   qui logit female ecta_cumulative-jpe_cumulative asinh*cites i.year `x', cluster(author)
   matrix female_stats[`i',1] = _b[`x']
   matrix female_stats[`i',2] = _se[`x']
   matrix female_stats[`i',3] = e(r2_p)


   qui logit new_fellow_ema ecta_cumulative-jpe_cumulative asinh*cites i.year `x', cluster(author)
   matrix new_fellow_stats[`i',1] = _b[`x']
   matrix new_fellow_stats[`i',2] = _se[`x']
   matrix new_fellow_stats[`i',3] = e(r2_p)


   local subword=substr("`x'", 6, .)
   qui putexcel A`i'= "`subword'"

   local i = `i' + 1


}


putexcel B1 = matrix(female_stats)


putexcel set word_regression_new_fellow_output.xls, replace
foreach x of varlist word_* {
   local subword=substr("`x'", 6, .)
   qui putexcel A`i'= "`subword'"
   local i = `i' + 1

}
putexcel B1 = matrix(new_fellow_stats)


