clear all
set more off
do install_packages.do

* Set this global to dropbox/your replication directory. If not set, directories
* will be set within individual .do files.
global dropbox_dir = "~/Dropbox"


if !missing("$dropbox_dir") {
	local dropbox_dir = "$dropbox_dir"
}
else {
	local dropbox_dir "C:/Users/Chris/Dropbox"
}
cd "`dropbox_dir'/ECM_Fellow_Study/Replication"

* Check for existence/possession of the non-publicly available dataset. 
* If this does not exist, we will only execute programs that use the publicly available data.
capture confirm file "`path_to_public_dataset"
if _rc == 0 {
	* Tables
	foreach x in 1 2 3 4 5 6 7 8 9 A4a A4b A5 A6 A7 A9 A10 A12 A13 A14 A15 A16 A17 {
		do code/table`x'.do
	}

	* Figures
	foreach x in 1 2 3AB_A1 3C 4 5 A3 {
		do code/figure`x'.do
	}
	do code/avg_top5.do
}
else {
	* Tables
	foreach x in 1 2 4 7 9 A5 A6 A7 A13 A14 A15 A16 A17 {
		do code/table`x'.do
	}

	* Figures
	foreach x in 1 3AB_A1 3C {
		do code/figure`x'.do
	}
}
